#include <math.h>
#include <stdlib.h>
#include <memory.h>
#include "global.h"
#include "macroblock.h"

#define SMALLBLOCK
#define max(a, b)  (((a) > (b)) ? (a) : (b)) 
#define min(a, b)  (((a) < (b)) ? (a) : (b)) 

int writeCoeff4x4_CAVLC (int block_type, int i, int j, int param, struct img_par *img);
int MBType2Value(int type,int i16offset);/*yummy*/
extern int skip_mv[2];
extern int MbCr[64];
extern char intra_mb_pos[72][92];
extern char intra_mb_pos1[72][92];
void WriteMb_CAVLC(struct img_par *img,int *intra_pred_modes,int cbp)
{
	int i,j;
	int mb_x,mb_y;
	int ii,jj,uv;
	int MbMode;
	int b4,b8;
  //mb header
  for (i=0; i < 4; i++)
	  for (j=0; j < 6; j++)
        img->nz_coeff [img->mb_x ][img->mb_y ][i][j]=0;  // CAVLC

  if(img->type==INTRA_IMG)
  {
	  if(img->imod == INTRA_MB_NEW)/*yummy*/
	  {
		  ue_v(img->i16offset);
		  ue_v(0);//chroma pred is DC
	  }
	  else
	  {
		  ue_v(0);//img->mb_mode is I_4x4
		  for(i=0;i<16;i++)
			  Write_Intra4x4PredictionMode(intra_pred_modes[i]);
		  ue_v(0);//chroma pred is DC
		  ue_v(NCBP[cbp][0]);//CBP
	  }
  }
  else
  {
	  if(img->mb_mode == COPY_MB)
	  {
		  img->cod_counter++;
		  if(img->current_mb_nr == img->total_number_mb)
		  {
			  ue_v(img->cod_counter);
		  }
		  return;
	  }
	  ue_v(img->cod_counter);
	  img->cod_counter = 0;
	  MbMode=MBType2Value(img->mb_mode,img->i16offset);/*yummy*/
	  ue_v(MbMode);//0(16x16),1(16x8),2(8x16),4(8x8),6(intra4x4),>6(intra16x16)
	  if(MbMode>5)	/*yummy*/
		  ue_v(0);//chroma pred is DC 
	  else if(MbMode==5)
	  {
		  for(i=0;i<16;i++)
		  {
			  Write_Intra4x4PredictionMode(intra_pred_modes[i]);
		  }
		  ue_v(0);//chroma pred is DC
		  ue_v(NCBP[cbp][0]);//CBP
	  }
	  else
	  {
		  if(img->mb_mode==1)
		  {
			se_v(curr_mvx-img->mv[0]);
			se_v(curr_mvy-img->mv[1]);
		  }
		  else if(img->mb_mode==2)
		  {
			se_v(curr_mvx1[0]-img->mv1[0][0]);
			se_v(curr_mvy1[0]-img->mv1[0][1]);
			se_v(curr_mvx1[1]-img->mv1[1][0]);
			se_v(curr_mvy1[1]-img->mv1[1][1]);
		  }
		  else if(img->mb_mode==3)
		  {
			se_v(curr_mvx2[0]-img->mv2[0][0]);
			se_v(curr_mvy2[0]-img->mv2[0][1]);
			se_v(curr_mvx2[1]-img->mv2[1][0]);
			se_v(curr_mvy2[1]-img->mv2[1][1]);
		  }
		  else
		  {
			  ue_v(img->SubMBType1);
			  ue_v(img->SubMBType2);
			  ue_v(img->SubMBType3);
			  ue_v(img->SubMBType4);
			    switch(img->SubMBType1)
				{
					case 0:
					se_v(curr_mvx3[0][0]-img->mv3[0][0][0]);
					se_v(curr_mvy3[0][0]-img->mv3[0][0][1]);
					break;
					
					case 1:
					se_v(curr_mvx3[1][0]-img->mv3[1][0][0]);
					se_v(curr_mvy3[1][0]-img->mv3[1][0][1]);
					se_v(curr_mvx3[1][1]-img->mv3[1][1][0]);
					se_v(curr_mvy3[1][1]-img->mv3[1][1][1]);
					break;
					
					case 2:
					se_v(curr_mvx3[2][0]-img->mv3[2][0][0]);
					se_v(curr_mvy3[2][0]-img->mv3[2][0][1]);
					se_v(curr_mvx3[2][1]-img->mv3[2][1][0]);
					se_v(curr_mvy3[2][1]-img->mv3[2][1][1]);
					break;
					
					case 3:
					se_v(curr_mvx3[3][0]-img->mv3[3][0][0]);
					se_v(curr_mvy3[3][0]-img->mv3[3][0][1]);
					se_v(curr_mvx3[3][1]-img->mv3[3][1][0]);
					se_v(curr_mvy3[3][1]-img->mv3[3][1][1]);
					se_v(curr_mvx3[3][2]-img->mv3[3][2][0]);
					se_v(curr_mvy3[3][2]-img->mv3[3][2][1]);
					se_v(curr_mvx3[3][3]-img->mv3[3][3][0]);
					se_v(curr_mvy3[3][3]-img->mv3[3][3][1]);
					break;
				}
				switch(img->SubMBType2)
				{
					case 0:
					se_v(curr_mvx3[0][1]-img->mv3[0][1][0]);
					se_v(curr_mvy3[0][1]-img->mv3[0][1][1]);
					break;
					
					case 1:
					se_v(curr_mvx3[1][2]-img->mv3[1][2][0]);
					se_v(curr_mvy3[1][2]-img->mv3[1][2][1]);
					se_v(curr_mvx3[1][3]-img->mv3[1][3][0]);
					se_v(curr_mvy3[1][3]-img->mv3[1][3][1]);
					break;
					
					case 2:
					se_v(curr_mvx3[2][2]-img->mv3[2][2][0]);
					se_v(curr_mvy3[2][2]-img->mv3[2][2][1]);
					se_v(curr_mvx3[2][3]-img->mv3[2][3][0]);
					se_v(curr_mvy3[2][3]-img->mv3[2][3][1]);
					break;
					
					case 3:
					se_v(curr_mvx3[3][4]-img->mv3[3][4][0]);
					se_v(curr_mvy3[3][4]-img->mv3[3][4][1]);
					se_v(curr_mvx3[3][5]-img->mv3[3][5][0]);
					se_v(curr_mvy3[3][5]-img->mv3[3][5][1]);
					se_v(curr_mvx3[3][6]-img->mv3[3][6][0]);
					se_v(curr_mvy3[3][6]-img->mv3[3][6][1]);
					se_v(curr_mvx3[3][7]-img->mv3[3][7][0]);
					se_v(curr_mvy3[3][7]-img->mv3[3][7][1]);
					break;
				}
				switch(img->SubMBType3)
				{
					case 0:
					se_v(curr_mvx3[0][2]-img->mv3[0][2][0]);
					se_v(curr_mvy3[0][2]-img->mv3[0][2][1]);
					break;
					
					case 1:
					se_v(curr_mvx3[1][4]-img->mv3[1][4][0]);
					se_v(curr_mvy3[1][4]-img->mv3[1][4][1]);
					se_v(curr_mvx3[1][5]-img->mv3[1][5][0]);
					se_v(curr_mvy3[1][5]-img->mv3[1][5][1]);
					break;
					
					case 2:
					se_v(curr_mvx3[2][4]-img->mv3[2][4][0]);
					se_v(curr_mvy3[2][4]-img->mv3[2][4][1]);
					se_v(curr_mvx3[2][5]-img->mv3[2][5][0]);
					se_v(curr_mvy3[2][5]-img->mv3[2][5][1]);
					break;
					
					case 3:
					se_v(curr_mvx3[3][8 ]-img->mv3[3][8 ][0]);
					se_v(curr_mvy3[3][8 ]-img->mv3[3][8 ][1]);
					se_v(curr_mvx3[3][9 ]-img->mv3[3][9 ][0]);
					se_v(curr_mvy3[3][9 ]-img->mv3[3][9 ][1]);
					se_v(curr_mvx3[3][10]-img->mv3[3][10][0]);
					se_v(curr_mvy3[3][10]-img->mv3[3][10][1]);
					se_v(curr_mvx3[3][11]-img->mv3[3][11][0]);
					se_v(curr_mvy3[3][11]-img->mv3[3][11][1]);
					break;
				}
				switch(img->SubMBType4)
				{
					case 0:
					se_v(curr_mvx3[0][3]-img->mv3[0][3][0]);
					se_v(curr_mvy3[0][3]-img->mv3[0][3][1]);
					break;
					
					case 1:
					se_v(curr_mvx3[1][6]-img->mv3[1][6][0]);
					se_v(curr_mvy3[1][6]-img->mv3[1][6][1]);
					se_v(curr_mvx3[1][7]-img->mv3[1][7][0]);
					se_v(curr_mvy3[1][7]-img->mv3[1][7][1]);
					break;
					
					case 2:
					se_v(curr_mvx3[2][6]-img->mv3[2][6][0]);
					se_v(curr_mvy3[2][6]-img->mv3[2][6][1]);
					se_v(curr_mvx3[2][7]-img->mv3[2][7][0]);
					se_v(curr_mvy3[2][7]-img->mv3[2][7][1]);
					break;
					
					case 3:
					se_v(curr_mvx3[3][12]-img->mv3[3][12][0]);
					se_v(curr_mvy3[3][12]-img->mv3[3][12][1]);
					se_v(curr_mvx3[3][13]-img->mv3[3][13][0]);
					se_v(curr_mvy3[3][13]-img->mv3[3][13][1]);
					se_v(curr_mvx3[3][14]-img->mv3[3][14][0]);
					se_v(curr_mvy3[3][14]-img->mv3[3][14][1]);
					se_v(curr_mvx3[3][15]-img->mv3[3][15][0]);
					se_v(curr_mvy3[3][15]-img->mv3[3][15][1]);
					break;
				}
		  }
			ue_v(NCBP[cbp][1]);//CBP
	  }
  }
  /*yummy*/
  if(cbp!=0||img->i16offset) se_v(0);//dquant

  //luma cofficient
  if(!img->i16offset)
  for (mb_y=0; mb_y < 4; mb_y += 2) 
  {
      for (mb_x=0; mb_x < 4; mb_x += 2)
      {       
        for (j=mb_y; j < mb_y+2; j++) 
        {
          jj=j/2;
          for (i=mb_x; i < mb_x+2; i++) 
          {
            ii=i/2;
            if ((cbp & (int)pow(2,ii+jj*2)) != 0)               /* check for any coeffisients */
            {
				writeCoeff4x4_CAVLC (LUMA, i, j, 0, img);//luma,param=0;             
            }
          }
        }
      }
  }

  /*write 16x16 MB*//*yummy*/
  else//(img->i16offset)
  {
	  writeCoeff4x4_CAVLC (LUMA_INTRA16x16DC, 0, 0, 0,img);
	  if (cbp & 15)
	  {
		  for (mb_y=0; mb_y < 4; mb_y += 2)
			  for (mb_x=0; mb_x < 4; mb_x += 2)/*??*/
				  for (j=mb_y; j < mb_y+2; j++)
					  for (i=mb_x; i < mb_x+2; i++)
					  {
						  b8      = 2*(j/2) + (i/2);
						  b4      = 2*(j&0x01) + (i&0x01);
						  writeCoeff4x4_CAVLC (LUMA_INTRA16x16AC, b8, b4, 0,img);// CAVLC
					  }
	  }
  }
  
  if (cbp > 15) 
  {
    for (uv=0; uv < 2; uv++) 
    {
      //param = uv;
      writeCoeff4x4_CAVLC (CHROMA_DC, 0, 0, uv, img);
    }
  }
  
  //  Bits for chroma AC-coeffs. 
  
  if (cbp >> 4 == 2) 
  {        
    for (mb_y=4; mb_y < 6; mb_y += 2) 
    {
      for (mb_x=0; mb_x < 4; mb_x += 2)
      {  
   
        for (j=mb_y; j < mb_y+2; j++) 
        {
          for (i=mb_x; i < mb_x+2; i++) 
          {
			//param = i << 4 | j;
            writeCoeff4x4_CAVLC (CHROMA_AC, i, j, i << 4 | j, img);
          }
        }
      }
    }
  }  
}

int predict_nnz(int i,int j,struct img_par *img)
{
  int Left_block,Top_block, pred_nnz;
  int cnt=0;
  int decr    = 1;

  int mb_available_up   = (img->mb_y == 0 ) ? 0 : 1;
  int mb_available_left = (img->mb_x == 0 ) ? 0 : 1;

  if (i)
    Left_block= img->nz_coeff [img->mb_x ][img->mb_y ][i-1][j];
  else
    Left_block= mb_available_left ? img->nz_coeff [img->mb_x-1 ][img->mb_y ][3][j] : -1;

  if (j)
    Top_block=  img->nz_coeff [img->mb_x ][img->mb_y ][i][j-1];
  else
  Top_block=  mb_available_up ? img->nz_coeff [img->mb_x ][img->mb_y-decr ][i][3] : -1;
 
  
  pred_nnz=0;
  if (Left_block>-1)
  {
    pred_nnz=Left_block;
    cnt++;
  }
  if (Top_block>-1)
  {
    pred_nnz+=Top_block;
    cnt++;
  }

  if (cnt==2)
    pred_nnz++;

  if (cnt)
    pred_nnz/=cnt; 
  return pred_nnz;
}

int predict_nnz_chroma(int i,int j, struct img_par *img)
{
  int Left_block,Top_block, pred_nnz;
  int cnt=0;
  int mb_y = img->mb_y;
  int decr    = 1;

  
  int mb_available_up   = (img->mb_y == 0 ) ? 0 : 1;
  int mb_available_left = (img->mb_x == 0 ) ? 0 : 1;

  if (i==1 || i==3)
    Left_block= img->nz_coeff [img->mb_x ][mb_y ][i-1][j];
  else
    Left_block= mb_available_left ? img->nz_coeff [img->mb_x-1 ][img->mb_y ][i+1][j] : -1;

  if (j==5)
    Top_block=  img->nz_coeff [img->mb_x ][img->mb_y ][i][j-1];
  else
    Top_block=  mb_available_up ? img->nz_coeff [img->mb_x ][img->mb_y-decr ][i][5] : -1;


  pred_nnz=0;
  if (Left_block>-1)
  {
    pred_nnz=Left_block;
    cnt++;
  }
  if (Top_block>-1)
  {
    pred_nnz+=Top_block;
    cnt++;
  }

  if (cnt==2)
    pred_nnz++;

  if (cnt)
    pred_nnz/=cnt; 
  return pred_nnz;
}

int writeCoeff4x4_CAVLC (int block_type, int i, int j, int param, struct img_par *img)
{ 
  int k,level,run,vlcnum;
  int numcoeff, lastcoeff, numtrailingones; 
  int numones, totzeros, zerosleft, numcoef;
  int numcoeff_vlc;
  int code, level_two_or_higher;
  int dptype = 0, bitcounttype = 0;
  int nnz, max_coeff_num = 0, cdc=0, cac=0;
  int subblock_x, subblock_y;
  
  int  mb_y = img->mb_y;

  int value1;

  int incVlc[] = {0,3,6,12,24,48,32768};  // maximum vlc = 6

  switch (block_type)
  {
  case LUMA:
    max_coeff_num = 16;
	break;

  case LUMA_INTRA16x16DC:
    max_coeff_num = 16;
    break;

  case LUMA_INTRA16x16AC:
    max_coeff_num = 15;
    break;

  case CHROMA_DC:
    max_coeff_num = 4;
    cdc = 1;
    break;

  case CHROMA_AC:
    max_coeff_num = 15;
    cac = 1;
    break;
  }


  numcoeff = 0;
  numtrailingones = 0;
  numones = 0;
  lastcoeff = 0;
  totzeros = 0;
  level = 1;

  for(k = 0; (k <= cdc?4:16)&& level !=0; k++)
  {
	  if(block_type == LUMA_INTRA16x16DC)/*yummy*/
	  {
		  level = img->cofy[k][0];
		  run =	img->cofy[k][1];
	  }
	  else if(!cdc)
	  {
		  level=img->cof[i][j][k][0];
		  run=  img->cof[i][j][k][1];
	  }
	  else
	  {
		  level=img->cofu[k][0][param];
		  run=  img->cofu[k][1][param];
	  }
	  if (level)
	  {
		  if (run)
			  totzeros += run;
		  if (abs(level) == 1)
		  {
			  numtrailingones ++;
			  numones ++;
			  if (numtrailingones > 3)
			  {
				  numtrailingones = 3; /* clip to 3 */
			  }
		  }
		  else
		  {
			  numtrailingones = 0;
		  }
		  numcoeff ++;
		  lastcoeff = k;
	  }
  }

  if (!cdc)
  {
    if (!cac)
    {
      // luma
      subblock_x = i;
        // horiz. position for coeff_count context
      subblock_y = j;
        // vert.  position for coeff_count context
      nnz = predict_nnz(subblock_x,subblock_y,img);
    }
    else
    {
      // chroma AC
      subblock_x = i;//param >> 4;
      subblock_y = j;//param & 15;
      nnz = predict_nnz_chroma(subblock_x,subblock_y,img);
    }

    img->nz_coeff [img->mb_x ][mb_y ][subblock_x][subblock_y] = numcoeff;


    if (nnz < 2)
    {
      numcoeff_vlc = 0;
    }
    else if (nnz < 4)
    {
      numcoeff_vlc = 1;
    }
    else if (nnz < 8)
    {
      numcoeff_vlc = 2;
    }
    else 
    {
      numcoeff_vlc = 3;
    }


  }
  else
  {
    // chroma DC (has its own VLC)
    // numcoeff_vlc not relevant
    numcoeff_vlc = 0;

    subblock_x = param;
    subblock_y = param;
  }

  if (!cdc)
    writeSyntaxElement_NumCoeffTrailingOnes(numcoeff_vlc, numcoeff, numtrailingones);
  else
    writeSyntaxElement_NumCoeffTrailingOnesChromaDC(numcoeff_vlc, numcoeff, numtrailingones);
  

  if (!numcoeff)
    return 0;//no_bits;

  if (numcoeff)
  {
    code = 0;
    for (k = lastcoeff; k > lastcoeff-numtrailingones; k--)
    {
      //level = pLevel[k]; // level
	  if(block_type == LUMA_INTRA16x16DC)
		  level = img->cofy[k][0];
	  else if(!cdc)
		level=img->cof[i][j][k][0];
	  else
		  level=img->cofu[k][0][param];
      if (abs(level) > 1)
      {
        exit(-1);
      }
      code <<= 1;
      if (level < 0)
      {
        code |= 0x1;
      }
    }

    if (numtrailingones)
    {
	  PutBits(numtrailingones,code);
    }

    // encode levels
    level_two_or_higher = 1;
    if (numcoeff > 3 && numtrailingones == 3)
      level_two_or_higher = 0;

    if (numcoeff > 10 && numtrailingones < 3)
      vlcnum = 1;
    else
      vlcnum = 0;

    for (k = lastcoeff - numtrailingones; k >= 0; k--)
    {
      //level = pLevel[k]; // level
	  if(block_type == LUMA_INTRA16x16DC)
		  level = img->cofy[k][0];
	  else if(!cdc)
		level=img->cof[i][j][k][0];
	  else
		  level=img->cofu[k][0][param];

      value1 = level;
      //currSE->type  = dptype;   

          if (level_two_or_higher)
          {
            if (value1 > 0)
              value1 --;
            else
              value1 ++;
            level_two_or_higher = 0;
          }

      //    encode level
      if (vlcnum == 0)
        writeSyntaxElement_Level_VLC1(value1);
      else
        writeSyntaxElement_Level_VLCN(value1,vlcnum);

      // update VLC table
      if (abs(level)>incVlc[vlcnum])
        vlcnum++;

      if (k == lastcoeff - numtrailingones && abs(level)>3)
        vlcnum = 2;
    }


    // encode total zeroes
    if (numcoeff < max_coeff_num)
    {
      vlcnum = numcoeff-1;
      if (!cdc)
        writeSyntaxElement_TotalZeros(totzeros, vlcnum);
      else
        writeSyntaxElement_TotalZerosChromaDC(totzeros, vlcnum);
    }

    // encode run before each coefficient
    zerosleft = totzeros;
    numcoef = numcoeff;
    for (k = lastcoeff; k >= 0; k--)
    {
      //run = pRun[k]; // run
	  if(block_type == LUMA_INTRA16x16DC)
		  run = img->cofy[k][1];
	  else if(!cdc)
		run=  img->cof[i][j][k][1];
	  else
		  run=  img->cofu[k][1][param];
      // for last coeff, run is remaining totzeros
      // when zerosleft is zero, remaining coeffs have 0 run
      if (numcoeff <= 1 || !zerosleft)
        break;

      if (numcoef > 1 && zerosleft) 
      {

        vlcnum = zerosleft - 1;
        if (vlcnum > RUNBEFORE_NUM-1)
          vlcnum = RUNBEFORE_NUM-1;

        writeSyntaxElement_Run(run, vlcnum);

        zerosleft -= run;
        numcoef --;
      }
    }
  }
  return 0;//no_bits;
}

int MBType2Value(int type,int i16offset)
{
	int value;

	if((type>0) && (type<4))		value = type-1;
	else if((type>3) && (type<8))	value = 4;
	else if(type==8)				value = 5;
	else							value = 5+i16offset;	/*yummy*/

	return value;
}

void IntraMb_Chroma(struct img_par *img)
{
  int cr_cbp=0;
  int width_cr=img->width_cr+IMG_PAD_SIZE;

  intrapred_chroma(img,img->pix_c_x,img->pix_c_y,0); 
  cr_cbp=intra_dct_chroma(0,cr_cbp,imgUV_org[0]+img->pix_c_y*width_cr+img->pix_c_x,MbCb,img);
  intrapred_chroma(img,img->pix_c_x,img->pix_c_y,1); 
  cr_cbp=intra_dct_chroma(1,cr_cbp,imgUV_org[1]+img->pix_c_y*width_cr+img->pix_c_x,MbCr,img);
  
  img->cbp += cr_cbp<<4;
}

int intrapred_luma_topleft(struct img_par *img,int img_x,int img_y,int *tot_intra_sad,int block_num)
{
  int i,j;
  int nonzero;

  for (j=0; j < BLOCK_SIZE; j++)
  {
  	i=j*4;
      img->mprr[DC_PRED][i] = 128;
      img->mprr[DC_PRED][i+1] = 128;
      img->mprr[DC_PRED][i+2] = 128;
      img->mprr[DC_PRED][i+3] = 128;
  }
  *tot_intra_sad+=Intra_Sad(img,imgY_org,img->mprr[DC_PRED]);
  
  img->ipredmode[1][1]=DC_PRED;
  img->intra_pred_modes[block_num] = -1;
          
  nonzero = dct_luma(imgY_org,img->mprr[DC_PRED],0,0,img);       
  return nonzero;
}

/*yummy*/
int intrapred_lumaMB_topleft(struct img_par *img,int img_x,int img_y,int *tot_intra_sad,int *imode)
{
  int j;

  for (j=0; j < 256; j+=16)
  {
      img->mprr_2[DC_PRED][j]	= 128;		img->mprr_2[DC_PRED][j+1] = 128;      
      img->mprr_2[DC_PRED][j+2] = 128;		img->mprr_2[DC_PRED][j+3] = 128;
      img->mprr_2[DC_PRED][j+4] = 128;		img->mprr_2[DC_PRED][j+5] = 128;      
      img->mprr_2[DC_PRED][j+6] = 128;		img->mprr_2[DC_PRED][j+7] = 128;
	  img->mprr_2[DC_PRED][j+8] = 128;		img->mprr_2[DC_PRED][j+9] = 128;      
      img->mprr_2[DC_PRED][j+10] = 128;		img->mprr_2[DC_PRED][j+11] = 128;
	  img->mprr_2[DC_PRED][j+12] = 128;		img->mprr_2[DC_PRED][j+13] = 128;      
      img->mprr_2[DC_PRED][j+14] = 128;		img->mprr_2[DC_PRED][j+15] = 128;
  }
  *tot_intra_sad+=IntraMB_Sad(img,imgY_org,img->mprr_2[DC_PRED]);
  *imode = DC_PRED_16;

  return *tot_intra_sad;
}

/*yummy*/
int intrapred_lumaMB_top(struct img_par *img,int img_x,int img_y,int *tot_intra_sad,int *imode)
{
  int i,j,s0;
  int s1,s2,s3,s4,s5,s6,s7,s8,s9,s10,s11,s12,s13,s14,s15,s16;
  int width=img->width+IMG_PAD_SIZE;  
  int temp= img_y*width;
  int img_offset = temp+img_x;
  int current_intra_sad;
  
  //pe=pf=pg=ph=pa=pb=pc=pd=128;
  s1  = imgY[ temp+img_x-1]; temp+=width;
  s2  = imgY[ temp+img_x-1]; temp+=width;
  s3  = imgY[ temp+img_x-1]; temp+=width;
  s4  = imgY[ temp+img_x-1]; temp+=width;
  s5  = imgY[ temp+img_x-1]; temp+=width;
  s6  = imgY[ temp+img_x-1]; temp+=width;
  s7  = imgY[ temp+img_x-1]; temp+=width;
  s8  = imgY[ temp+img_x-1]; temp+=width;
  s9  = imgY[ temp+img_x-1]; temp+=width;
  s10 = imgY[ temp+img_x-1]; temp+=width;
  s11 = imgY[ temp+img_x-1]; temp+=width;
  s12 = imgY[ temp+img_x-1]; temp+=width;
  s13 = imgY[ temp+img_x-1]; temp+=width;
  s14 = imgY[ temp+img_x-1]; temp+=width;
  s15 = imgY[ temp+img_x-1]; temp+=width;
  s16 = imgY[ temp+img_x-1];
  //px=imgY[(img_y-1)*width+img_x-1];
  
  ///////////////////////////////
  // make DC prediction
  ///////////////////////////////
  s0 = (s1+s2+s3+s4+s5+s6+s7+s8+s9+s10+s11+s12+s13+s14+s15+s16+ 8)>>4;
  for (j=0; j < 256; j+=16)
  {
      img->mprr_2[DC_PRED][j]	= s0;		img->mprr_2[DC_PRED][j+1] = s0;
      img->mprr_2[DC_PRED][j+2] = s0;		img->mprr_2[DC_PRED][j+3] = s0;
	  img->mprr_2[DC_PRED][j+4] = s0;		img->mprr_2[DC_PRED][j+5] = s0;
      img->mprr_2[DC_PRED][j+6] = s0;		img->mprr_2[DC_PRED][j+7] = s0;
	  img->mprr_2[DC_PRED][j+8] = s0;		img->mprr_2[DC_PRED][j+9] = s0;
      img->mprr_2[DC_PRED][j+10] = s0;		img->mprr_2[DC_PRED][j+11] = s0;
	  img->mprr_2[DC_PRED][j+12] = s0;		img->mprr_2[DC_PRED][j+13] = s0;
      img->mprr_2[DC_PRED][j+14] = s0;		img->mprr_2[DC_PRED][j+15] = s0;
  }
  *tot_intra_sad = IntraMB_Sad(img,imgY_org+img_offset,img->mprr_2[DC_PRED]);
  *imode = DC_PRED_16;
  ///////////////////////////////
  // make horiz and vert prediction
  ///////////////////////////////

  for (i=0; i < 16; i++)
  {
    img->mprr_2[HOR_PRED][i]	 = s1;
    img->mprr_2[HOR_PRED][16+i]  = s2;
    img->mprr_2[HOR_PRED][32+i]  = s3;
    img->mprr_2[HOR_PRED][48+i]  = s4;
	img->mprr_2[HOR_PRED][64+i]	 = s5;
    img->mprr_2[HOR_PRED][80+i]  = s6;
    img->mprr_2[HOR_PRED][96+i]  = s7;
    img->mprr_2[HOR_PRED][112+i] = s8;
	img->mprr_2[HOR_PRED][128+i] = s9;
    img->mprr_2[HOR_PRED][144+i] = s10;
    img->mprr_2[HOR_PRED][160+i] = s11;
    img->mprr_2[HOR_PRED][176+i] = s12;
	img->mprr_2[HOR_PRED][192+i] = s13;
    img->mprr_2[HOR_PRED][208+i] = s14;
    img->mprr_2[HOR_PRED][224+i] = s15;
    img->mprr_2[HOR_PRED][240+i] = s16;
  }  
  current_intra_sad = IntraMB_Sad(img,imgY_org+img_offset,img->mprr_2[HOR_PRED]);
  if( current_intra_sad <= (*tot_intra_sad))
  {
	  *tot_intra_sad = current_intra_sad;
	  *imode = HOR_PRED_16;
  }
  return *tot_intra_sad; 
}

int intrapred_luma_top(struct img_par *img,int img_x,int img_y,int *tot_intra_sad,int block_num)
{
  int i,j,s0;
  int pi,pj,pk,pl;
  int block_x=img_x&15;
  int block_y=img_y&15;
  int width=img->width+IMG_PAD_SIZE;
  int best_intra_sad;
  int upMode,leftMode,mostProbableMode,best_ipmode;
  double lambda_mode = QP2QUANT[max(0,img->qp-SHIFT_QP)];
  int nonzero;
  int img_offset = img_y*width+img_x;
  int current_intra_sad;
  
  //pe=pf=pg=ph=pa=pb=pc=pd=128;
  pi=imgY[ img_y   *width+img_x-1];
  pj=imgY[(img_y+1)*width+img_x-1];
  pk=imgY[(img_y+2)*width+img_x-1];
  pl=imgY[(img_y+3)*width+img_x-1];
  
  ///////////////////////////////
  // make DC prediction
  ///////////////////////////////
  s0 = (pi + pj + pk + pl + 2)>>2;
  for (j=0; j < BLOCK_SIZE; j++)
  {
	  i=j<<2;
      img->mprr[DC_PRED][i] = s0;
      img->mprr[DC_PRED][i+1] = s0;
      img->mprr[DC_PRED][i+2] = s0;
      img->mprr[DC_PRED][i+3] = s0;
  }

  ///////////////////////////////
  // make horiz and vert prediction
  ///////////////////////////////

  for (i=0; i < BLOCK_SIZE; i++)
  {
    img->mprr[HOR_PRED][i]  = pi;
    img->mprr[HOR_PRED][4+i]  = pj;
    img->mprr[HOR_PRED][8+i]  = pk;
    img->mprr[HOR_PRED][12+i]  = pl;
  }

    // Mode HOR_UP_PRED
    img->mprr[HOR_UP_PRED][0] = (pi + pj + 1) >>1;
    img->mprr[HOR_UP_PRED][1] = (pi + 2*pj + pk + 2) >>2;
    img->mprr[HOR_UP_PRED][2] = 
    img->mprr[HOR_UP_PRED][4] = (pj + pk + 1) >>1;
    img->mprr[HOR_UP_PRED][3] = 
    img->mprr[HOR_UP_PRED][5] = (pj + 2*pk + pl + 2) >>2;
    img->mprr[HOR_UP_PRED][6] = 
    img->mprr[HOR_UP_PRED][8] = (pk + pl + 1) >>1;
    img->mprr[HOR_UP_PRED][7] = 
    img->mprr[HOR_UP_PRED][9] = (pk + 2*pl + pl + 2) >>2;
    img->mprr[HOR_UP_PRED][12] = 
    img->mprr[HOR_UP_PRED][10] = 
    img->mprr[HOR_UP_PRED][11] = 
    img->mprr[HOR_UP_PRED][13] = 
    img->mprr[HOR_UP_PRED][14] = 
    img->mprr[HOR_UP_PRED][15] = pl;
    
    upMode = img->ipredmode[img_x/BLOCK_SIZE+1][img_y>>2];
    leftMode = img->ipredmode[img_x/BLOCK_SIZE][(img_y>>2)+1];
    mostProbableMode  = (upMode < 0 || leftMode < 0) ? DC_PRED : upMode < leftMode ? upMode : leftMode;
    
    best_intra_sad  = (DC_PRED == mostProbableMode) ? 0 : (int)floor(4 * lambda_mode );			  
    best_intra_sad += Intra_Sad(img,imgY_org+img_offset,img->mprr[DC_PRED]);                
    best_ipmode=DC_PRED;

    current_intra_sad  = (HOR_PRED == mostProbableMode) ? 0 : (int)floor(4 * lambda_mode );			  
    current_intra_sad += Intra_Sad(img,imgY_org+img_offset,img->mprr[HOR_PRED]);            
    if (current_intra_sad < best_intra_sad) 
    {
    	best_intra_sad=current_intra_sad;
        best_ipmode=HOR_PRED;
    }
    
    current_intra_sad  = (HOR_UP_PRED == mostProbableMode) ? 0 : (int)floor(4 * lambda_mode );			  
    current_intra_sad += Intra_Sad(img,imgY_org+img_offset,img->mprr[HOR_UP_PRED]);            
    if (current_intra_sad < best_intra_sad) 
    {
    	best_intra_sad=current_intra_sad;
        best_ipmode=HOR_UP_PRED;
    }
    
    *tot_intra_sad+=best_intra_sad;
  
  img->ipredmode[(img_x>>2)+1][(img_y>>2)+1]=best_ipmode;
  img->intra_pred_modes[block_num] = mostProbableMode == best_ipmode ? -1 : best_ipmode < mostProbableMode ? best_ipmode : best_ipmode-1;
          
  nonzero = dct_luma(imgY_org+img_offset,img->mprr[best_ipmode],block_x,block_y,img);       
  return nonzero; 
}

int intrapred_luma_left(struct img_par *img,int img_x,int img_y,int *tot_intra_sad,int block_num)
{
  int i,j,s0;
  int pa,pb,pc,pd,pe,pf,pg,ph,pi,pj,pk,pl,px;
  int pic_block_x=img_x>>2;
  int pic_block_y=img_y>>2;
  int block_x=img_x&15;
  int block_y=img_y&15;
  int width=img->width+IMG_PAD_SIZE;
  int best_intra_sad;
  int upMode,leftMode,mostProbableMode,best_ipmode;
  double lambda_mode = QP2QUANT[max(0,img->qp-SHIFT_QP)];
  int nonzero;
  int temp = img_y*width;
  int img_offset = temp+img_x;
  int current_intra_sad;

  temp -= width+img_x;  
  pa=imgY[temp];
  pb=imgY[temp+1];
  pc=imgY[temp+2];
  pd=imgY[temp+3];
  
  pe=imgY[temp+4];
  pf=imgY[temp+5];
  pg=imgY[temp+6];
  ph=imgY[temp+7];
  
  pi=pj=pk=pl=128;
  
  px=128;
  ///////////////////////////////
  // make DC prediction
  ///////////////////////////////
    // left edge
    s0 = (pa + pb + pc + pd + 2)>>2;             
  for (j=0; j < BLOCK_SIZE; j++)
  {
	  i=j*4;
      img->mprr[DC_PRED][i] = s0;
      img->mprr[DC_PRED][i+1] = s0;
      img->mprr[DC_PRED][i+2] = s0;
      img->mprr[DC_PRED][i+3] = s0;
  }

  ///////////////////////////////
  // make horiz and vert prediction
  ///////////////////////////////

  for (i=0; i < BLOCK_SIZE; i++)
  {
	img->mprr[VERT_PRED][i*4] = pa;
	img->mprr[VERT_PRED][i*4+1] = pb;
	img->mprr[VERT_PRED][i*4+2] = pc;
	img->mprr[VERT_PRED][i*4+3] = pd;
  }

    // Mode DIAG_DOWN_LEFT_PRED
    img->mprr[DIAG_DOWN_LEFT_PRED][0] = (pa + pc + (pb<<1) + 2)>>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][1] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][4] = (pb + pd + (pc<<1) + 2)>>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][2] =
    img->mprr[DIAG_DOWN_LEFT_PRED][5] =
    img->mprr[DIAG_DOWN_LEFT_PRED][8] = (pc + pe + (pd<<1) + 2)>>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][3] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][6] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][9] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][12] = (pd + pf + (pe<<1) + 2)>>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][7] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][10] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][13] = (pe + pg + (pf<<1) + 2)>>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][11] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][14] = (pf + ph + (pg<<1) + 2)>>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][15] = (pg + 3*(ph) + 2)>>2;

    // Mode VERT_LEFT_PRED
    img->mprr[VERT_LEFT_PRED][0] = (pa + pb + 1)>>1;
    img->mprr[VERT_LEFT_PRED][1] = 
    img->mprr[VERT_LEFT_PRED][8] = (pb + pc + 1)>>1;
    img->mprr[VERT_LEFT_PRED][2] = 
    img->mprr[VERT_LEFT_PRED][9] = (pc + pd + 1)>>1;
    img->mprr[VERT_LEFT_PRED][3] = 
    img->mprr[VERT_LEFT_PRED][10] = (pd + pe + 1)>>1;
    img->mprr[VERT_LEFT_PRED][11] = (pe + pf + 1)>>1;
    img->mprr[VERT_LEFT_PRED][4] = (pa + (pb<<1) + pc + 2)>>2;
    img->mprr[VERT_LEFT_PRED][5] = 
    img->mprr[VERT_LEFT_PRED][12] = (pb + (pc<<1) + pd + 2)>>2;
    img->mprr[VERT_LEFT_PRED][6] = 
    img->mprr[VERT_LEFT_PRED][13] = (pc + (pd<<1) + pe + 2)>>2;
    img->mprr[VERT_LEFT_PRED][7] = 
    img->mprr[VERT_LEFT_PRED][14] = (pd + (pe<<1) + pf + 2)>>2;
    img->mprr[VERT_LEFT_PRED][15] = (pe + (pf<<1) + pg + 2)>>2;
    
    upMode = img->ipredmode[(img_x>>2)+1][img_y>>2];
    leftMode = img->ipredmode[img_x>>2][(img_y>>2)+1];
    mostProbableMode  = (upMode < 0 || leftMode < 0) ? DC_PRED : upMode < leftMode ? upMode : leftMode;
    
    best_intra_sad  = (DC_PRED == mostProbableMode) ? 0 : (int)floor(4 * lambda_mode );			  
    best_intra_sad += Intra_Sad(img,imgY_org+img_offset,img->mprr[DC_PRED]);                
    best_ipmode=DC_PRED;

    current_intra_sad  = (VERT_PRED == mostProbableMode) ? 0 : (int)floor(4 * lambda_mode );			  
    current_intra_sad += Intra_Sad(img,imgY_org+img_offset,img->mprr[VERT_PRED]);            
    if (current_intra_sad < best_intra_sad) 
    {
    	best_intra_sad=current_intra_sad;
        best_ipmode=VERT_PRED;
    }
    
    current_intra_sad  = (DIAG_DOWN_LEFT_PRED == mostProbableMode) ? 0 : (int)floor(4 * lambda_mode );			  
    current_intra_sad += Intra_Sad(img,imgY_org+img_offset,img->mprr[DIAG_DOWN_LEFT_PRED]);            
    if (current_intra_sad < best_intra_sad) 
    {
    	best_intra_sad=current_intra_sad;
        best_ipmode=DIAG_DOWN_LEFT_PRED;
    }
    
    current_intra_sad  = (VERT_LEFT_PRED == mostProbableMode) ? 0 : (int)floor(4 * lambda_mode );			  
    current_intra_sad += Intra_Sad(img,imgY_org+img_offset,img->mprr[VERT_LEFT_PRED]);            
    if (current_intra_sad < best_intra_sad) 
    {
    	best_intra_sad=current_intra_sad;
        best_ipmode=VERT_LEFT_PRED;
    }
    
    *tot_intra_sad+=best_intra_sad;
  
  img->ipredmode[pic_block_x+1][pic_block_y+1]=best_ipmode;
  img->intra_pred_modes[block_num] = mostProbableMode == best_ipmode ? -1 : best_ipmode < mostProbableMode ? best_ipmode : best_ipmode-1;
          
  nonzero = dct_luma(imgY_org+img_offset,img->mprr[best_ipmode],block_x,block_y,img);       
  return nonzero; 
}

/*yummy*/
int intrapred_lumaMB_left(struct img_par *img,int img_x,int img_y,int *tot_intra_sad,int *imode)
{
  int i,j,s0;  
  int s1,s2,s3,s4,s5,s6,s7,s8,s9,s10,s11,s12,s13,s14,s15,s16;  
  int width=img->width+IMG_PAD_SIZE;
  int img_offset = img_y*width+img_x;
  int temp = img_offset-width;
  int current_intra_sad;

  /*up pixel*/
  s1 = imgY[temp];
  s2 = imgY[temp+1];
  s3 = imgY[temp+2];
  s4 = imgY[temp+3];
  s5 = imgY[temp+4];
  s6 = imgY[temp+5];
  s7 = imgY[temp+6];
  s8 = imgY[temp+7];
  s9 = imgY[temp+8];
  s10 = imgY[temp+9];
  s11 = imgY[temp+10];
  s12 = imgY[temp+11];
  s13 = imgY[temp+12];
  s14 = imgY[temp+13];
  s15 = imgY[temp+14];
  s16 = imgY[temp+15];

  ///////////////////////////////
  // make DC prediction
  ///////////////////////////////
    // left edge
  s0 = (s1 +s2 +s3 +s4 +s5 +s6 +s7 +s8 +s9 +s10 +s11 +s12 +s13 +s14 +s15 +s16 + 8)>>4;          
  for (j=0; j < 256; j+=16)
  {
      img->mprr_2[DC_PRED][j]	= s0;		img->mprr_2[DC_PRED][j+1] = s0;
      img->mprr_2[DC_PRED][j+2] = s0;		img->mprr_2[DC_PRED][j+3] = s0;
	  img->mprr_2[DC_PRED][j+4] = s0;		img->mprr_2[DC_PRED][j+5] = s0;
      img->mprr_2[DC_PRED][j+6] = s0;		img->mprr_2[DC_PRED][j+7] = s0;
	  img->mprr_2[DC_PRED][j+8] = s0;		img->mprr_2[DC_PRED][j+9] = s0;
      img->mprr_2[DC_PRED][j+10] = s0;		img->mprr_2[DC_PRED][j+11] = s0;
	  img->mprr_2[DC_PRED][j+12] = s0;		img->mprr_2[DC_PRED][j+13] = s0;
      img->mprr_2[DC_PRED][j+14] = s0;		img->mprr_2[DC_PRED][j+15] = s0;
  }
  *tot_intra_sad = IntraMB_Sad(img,imgY_org+img_offset,img->mprr_2[DC_PRED]);
  *imode = DC_PRED_16;

  ///////////////////////////////
  // make horiz and vert prediction
  ///////////////////////////////

  for (i=0; i < 256; i+=16)
  {
    img->mprr_2[VERT_PRED][i]	  = s1;
    img->mprr_2[VERT_PRED][1+i]  = s2;
    img->mprr_2[VERT_PRED][2+i]  = s3;
    img->mprr_2[VERT_PRED][3+i]  = s4;
	img->mprr_2[VERT_PRED][4+i]  = s5;
    img->mprr_2[VERT_PRED][5+i]  = s6;
    img->mprr_2[VERT_PRED][6+i]  = s7;
    img->mprr_2[VERT_PRED][7+i] = s8;
	img->mprr_2[VERT_PRED][8+i] = s9;
    img->mprr_2[VERT_PRED][9+i] = s10;
    img->mprr_2[VERT_PRED][10+i] = s11;
    img->mprr_2[VERT_PRED][11+i] = s12;
	img->mprr_2[VERT_PRED][12+i] = s13;
    img->mprr_2[VERT_PRED][13+i] = s14;
    img->mprr_2[VERT_PRED][14+i] = s15;
    img->mprr_2[VERT_PRED][15+i] = s16;
  } 
  current_intra_sad = IntraMB_Sad(img,imgY_org+img_offset,img->mprr_2[VERT_PRED]);
  if( current_intra_sad <= (*tot_intra_sad))
  {
	  *tot_intra_sad = current_intra_sad;
	  *imode = VERT_PRED_16;
  }
  return *tot_intra_sad; 
}

int intrapred_luma_noright(struct img_par *img,int img_x,int img_y,int *tot_intra_sad,int block_num)
{
  int i,j,s0;
  int pa,pb,pc,pd,pe,pf,pg,ph,pi,pj,pk,pl,px;
  int pic_block_x=img_x>>2;
  int pic_block_y=img_y>>2;
  int block_x=img_x&15;
  int block_y=img_y&15;
  int width=img->width+IMG_PAD_SIZE;
  int best_intra_sad;
  int upMode,leftMode,mostProbableMode,best_ipmode,ipmode;
  double lambda_mode = QP2QUANT[max(0,img->qp-SHIFT_QP)];
  int nonzero;
  int img_offset = img_y*width+img_x;
  int temp = img_offset-width;
  int current_intra_sad;

  pa=imgY[temp];
  pb=imgY[temp+1];
  pc=imgY[temp+2];
  pd=imgY[temp+3];

  pe=pf=pg=ph=pd;
    
  px=imgY[temp-1]; temp+=width;
  pi=imgY[temp-1]; temp+=width;
  pj=imgY[temp-1]; temp+=width;
  pk=imgY[temp-1]; temp+=width;
  pl=imgY[temp-1];
  
  
  ///////////////////////////////
  // make DC prediction
  ///////////////////////////////
 
  s0 = (pa + pb + pc + pd + pi + pj + pk + pl + 4)>>3;
  for (j=0; j < BLOCK_SIZE; j++)
  {
  	  i=j<<2;
      img->mprr[DC_PRED][i] = s0;
      img->mprr[DC_PRED][i+1] = s0;
      img->mprr[DC_PRED][i+2] = s0;
      img->mprr[DC_PRED][i+3] = s0;
  }

  ///////////////////////////////
  // make horiz and vert prediction
  ///////////////////////////////

  for (i=0; i < BLOCK_SIZE; i++)
  {
    img->mprr[VERT_PRED][i*4] = pa;
    img->mprr[VERT_PRED][i*4+1] = pb;
    img->mprr[VERT_PRED][i*4+2] = pc;
    img->mprr[VERT_PRED][i*4+3] = pd;
    img->mprr[HOR_PRED][i]  = pi;
    img->mprr[HOR_PRED][4+i]  = pj;
    img->mprr[HOR_PRED][8+i]  = pk;
    img->mprr[HOR_PRED][12+i]  = pl;
  }

    // Mode DIAG_DOWN_LEFT_PRED
    img->mprr[DIAG_DOWN_LEFT_PRED][0] = (pa + pc + (pb<<1) + 2) >>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][1] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][4] = (pb + pd + (pc<<1) + 2) >>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][2] =
    img->mprr[DIAG_DOWN_LEFT_PRED][5] =
    img->mprr[DIAG_DOWN_LEFT_PRED][8] = (pc + pe + (pd<<1) + 2) >>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][3] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][6] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][9] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][12] = (pd + pf + (pe<<1) + 2) >>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][7] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][10] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][13] = (pe + pg + (pf<<1) + 2) >>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][11] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][14] = (pf + ph + (pg<<1) + 2) >>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][15] = (pg + 3*(ph) + 2) >>2;

    // Mode VERT_LEFT_PRED
    img->mprr[VERT_LEFT_PRED][0] = (pa + pb + 1) >>1;
    img->mprr[VERT_LEFT_PRED][1] = 
    img->mprr[VERT_LEFT_PRED][8] = (pb + pc + 1) >>1;
    img->mprr[VERT_LEFT_PRED][2] = 
    img->mprr[VERT_LEFT_PRED][9] = (pc + pd + 1) >>1;
    img->mprr[VERT_LEFT_PRED][3] = 
    img->mprr[VERT_LEFT_PRED][10] = (pd + pe + 1) >>1;
    img->mprr[VERT_LEFT_PRED][11] = (pe + pf + 1) >>1;
    img->mprr[VERT_LEFT_PRED][4] = (pa + (pb<<1) + pc + 2) >>2;
    img->mprr[VERT_LEFT_PRED][5] = 
    img->mprr[VERT_LEFT_PRED][12] = (pb + (pc<<1) + pd + 2) >>2;
    img->mprr[VERT_LEFT_PRED][6] = 
    img->mprr[VERT_LEFT_PRED][13] = (pc + (pd<<1) + pe + 2) >>2;
    img->mprr[VERT_LEFT_PRED][7] = 
    img->mprr[VERT_LEFT_PRED][14] = (pd + (pe<<1) + pf + 2) >>2;
    img->mprr[VERT_LEFT_PRED][15] = (pe + (pf<<1) + pg + 2) >>2;

     // Mode HOR_UP_PRED
    img->mprr[HOR_UP_PRED][0] = (pi + pj + 1) >>1;
    img->mprr[HOR_UP_PRED][1] = (pi + (pj<<1) + pk + 2) >>2;
    img->mprr[HOR_UP_PRED][2] = 
    img->mprr[HOR_UP_PRED][4] = (pj + pk + 1) >>1;
    img->mprr[HOR_UP_PRED][3] = 
    img->mprr[HOR_UP_PRED][5] = (pj + (pk<<1) + pl + 2) >>2;
    img->mprr[HOR_UP_PRED][6] = 
    img->mprr[HOR_UP_PRED][8] = (pk + pl + 1) >>1;
    img->mprr[HOR_UP_PRED][7] = 
    img->mprr[HOR_UP_PRED][9] = (pk + (pl<<1) + pl + 2) >>2;
    img->mprr[HOR_UP_PRED][12] = 
    img->mprr[HOR_UP_PRED][10] = 
    img->mprr[HOR_UP_PRED][11] = 
    img->mprr[HOR_UP_PRED][13] = 
    img->mprr[HOR_UP_PRED][14] = 
    img->mprr[HOR_UP_PRED][15] = pl;

    // Mode DIAG_DOWN_RIGHT_PRED
    img->mprr[DIAG_DOWN_RIGHT_PRED][12] = (pl + (pk<<1) + pj + 2) >>2; 
    img->mprr[DIAG_DOWN_RIGHT_PRED][8] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][13] = (pk + (pj<<1) + pi + 2) >>2; 
    img->mprr[DIAG_DOWN_RIGHT_PRED][4] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][9] = 
    img->mprr[DIAG_DOWN_RIGHT_PRED][14] = (pj + (pi<<1) + px + 2) >>2; 
    img->mprr[DIAG_DOWN_RIGHT_PRED][0] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][5] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][10] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][15] = (pi + (px<<1) + pa + 2) >>2; 
    img->mprr[DIAG_DOWN_RIGHT_PRED][1] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][6] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][11] = (px + (pa<<1) + pb + 2) >>2;
    img->mprr[DIAG_DOWN_RIGHT_PRED][2] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][7] = (pa + (pb<<1) + pc + 2) >>2;
    img->mprr[DIAG_DOWN_RIGHT_PRED][3] = (pb + (pc<<1) + pd + 2) >>2;

     // Mode VERT_RIGHT_PRED
    img->mprr[VERT_RIGHT_PRED][0] = 
    img->mprr[VERT_RIGHT_PRED][9] = (px + pa + 1) >>1;
    img->mprr[VERT_RIGHT_PRED][1] = 
    img->mprr[VERT_RIGHT_PRED][10] = (pa + pb + 1) >>1;
    img->mprr[VERT_RIGHT_PRED][2] = 
    img->mprr[VERT_RIGHT_PRED][11] = (pb + pc + 1) >>1;
    img->mprr[VERT_RIGHT_PRED][3] = (pc + pd + 1) >>1;
    img->mprr[VERT_RIGHT_PRED][4] = 
    img->mprr[VERT_RIGHT_PRED][13] = (pi + (px<<1) + pa + 2) >>2;
    img->mprr[VERT_RIGHT_PRED][5] = 
    img->mprr[VERT_RIGHT_PRED][14] = (px + (pa<<1) + pb + 2) >>2;
    img->mprr[VERT_RIGHT_PRED][6] = 
    img->mprr[VERT_RIGHT_PRED][15] = (pa + (pb<<1) + pc + 2) >>2;
    img->mprr[VERT_RIGHT_PRED][7] = (pb + (pc<<1) + pd + 2) >>2;
    img->mprr[VERT_RIGHT_PRED][8] = (px + (pi<<1) + pj + 2) >>2;
    img->mprr[VERT_RIGHT_PRED][12] = (pi + (pj<<1) + pk + 2) >>2;

    // Mode HOR_DOWN_PRED
    img->mprr[HOR_DOWN_PRED][0] = 
    img->mprr[HOR_DOWN_PRED][6] = (px + pi + 1) >>1;
    img->mprr[HOR_DOWN_PRED][1] = 
    img->mprr[HOR_DOWN_PRED][7] = (pi + (px<<1) + pa + 2) >>2;
    img->mprr[HOR_DOWN_PRED][2] = (px + (pa<<1) + pb + 2) >>2;
    img->mprr[HOR_DOWN_PRED][3] = (pa + (pb<<1) + pc + 2) >>2;
    img->mprr[HOR_DOWN_PRED][4] = 
    img->mprr[HOR_DOWN_PRED][10] = (pi + pj + 1) >>1;
    img->mprr[HOR_DOWN_PRED][5] = 
    img->mprr[HOR_DOWN_PRED][11] = (px + (pi<<1) + pj + 2) >>2;
    img->mprr[HOR_DOWN_PRED][8] = 
    img->mprr[HOR_DOWN_PRED][14] = (pj + pk + 1) >>1;
    img->mprr[HOR_DOWN_PRED][9] = 
    img->mprr[HOR_DOWN_PRED][15] = (pi + (pj<<1) + pk + 2) >>2;
    img->mprr[HOR_DOWN_PRED][12] = (pk + pl + 1) >>1;
    img->mprr[HOR_DOWN_PRED][13] = (pj + (pk<<1) + pl + 2) >>2;
    
    best_intra_sad=MAX_VALUE; 		  
    upMode = img->ipredmode[pic_block_x+1][pic_block_y];
    leftMode = img->ipredmode[pic_block_x][pic_block_y+1];
    mostProbableMode  = (upMode < 0 || leftMode < 0) ? DC_PRED : upMode < leftMode ? upMode : leftMode;
    for (ipmode=0; ipmode < NO_INTRA_PMODE; ipmode++)
    {			  
	current_intra_sad  = (ipmode == mostProbableMode) ? 0 : (int)floor(4 * lambda_mode );			  
        current_intra_sad += Intra_Sad(img,imgY_org+img_offset,img->mprr[ipmode]);        
        if (current_intra_sad < best_intra_sad) 
        {
           best_intra_sad=current_intra_sad;
           best_ipmode=ipmode;
        }      
    }
    *tot_intra_sad += best_intra_sad;
    img->ipredmode[pic_block_x+1][pic_block_y+1]=best_ipmode;
    img->intra_pred_modes[block_num] = mostProbableMode == best_ipmode ? -1 : best_ipmode < mostProbableMode ? best_ipmode : best_ipmode-1;
		                            
    nonzero = dct_luma(imgY_org+img_offset,img->mprr[best_ipmode],block_x,block_y,img);     
  return nonzero;
}

/*yummy*/
int intrapred_lumaMB_other(struct img_par *img,int img_x,int img_y,int *tot_intra_sad,int *imode)
{
  int i,j,s0;  
  int s1,s2,s3,s4,s5,s6,s7,s8,s9,s10,s11,s12,s13,s14,s15,s16;
  int ss1,ss2,ss3,ss4,ss5,ss6,ss7,ss8,ss9,ss10,ss11,ss12,ss13,ss14,ss15,ss16;
  int width=img->width+IMG_PAD_SIZE;
  int img_offset = img_y*width+img_x;
  int temp = img_offset-width;
  int current_intra_sad;
  int ih,iv;
  int ib,ic,iaa;

  /*up pixel*/
  s1 = imgY[temp];
  s2 = imgY[temp+1];
  s3 = imgY[temp+2];
  s4 = imgY[temp+3];
  s5 = imgY[temp+4];
  s6 = imgY[temp+5];
  s7 = imgY[temp+6];
  s8 = imgY[temp+7];
  s9 = imgY[temp+8];
  s10 = imgY[temp+9];
  s11 = imgY[temp+10];
  s12 = imgY[temp+11];
  s13 = imgY[temp+12];
  s14 = imgY[temp+13];
  s15 = imgY[temp+14];
  s16 = imgY[temp+15];

  /*left pixel*/
  temp +=width-1;
  ss1  = imgY[temp]; temp +=width;
  ss2  = imgY[temp]; temp +=width;
  ss3  = imgY[temp]; temp +=width;
  ss4  = imgY[temp]; temp +=width;
  ss5  = imgY[temp]; temp +=width;
  ss6  = imgY[temp]; temp +=width;
  ss7  = imgY[temp]; temp +=width;
  ss8  = imgY[temp]; temp +=width;
  ss9  = imgY[temp]; temp +=width;
  ss10 = imgY[temp]; temp +=width;
  ss11 = imgY[temp]; temp +=width;
  ss12 = imgY[temp]; temp +=width;
  ss13 = imgY[temp]; temp +=width;
  ss14 = imgY[temp]; temp +=width;
  ss15 = imgY[temp]; temp +=width;
  ss16 = imgY[temp];

  ///////////////////////////////
  // make horiz and vert prediction
  ///////////////////////////////

  for (i=0; i < 256; i+=16)
  {
    img->mprr_2[VERT_PRED][i]	  = s1;
    img->mprr_2[VERT_PRED][1+i]  = s2;
    img->mprr_2[VERT_PRED][2+i]  = s3;
    img->mprr_2[VERT_PRED][3+i]  = s4;
	img->mprr_2[VERT_PRED][4+i]  = s5;
    img->mprr_2[VERT_PRED][5+i]  = s6;
    img->mprr_2[VERT_PRED][6+i]  = s7;
    img->mprr_2[VERT_PRED][7+i] = s8;
	img->mprr_2[VERT_PRED][8+i] = s9;
    img->mprr_2[VERT_PRED][9+i] = s10;
    img->mprr_2[VERT_PRED][10+i] = s11;
    img->mprr_2[VERT_PRED][11+i] = s12;
	img->mprr_2[VERT_PRED][12+i] = s13;
    img->mprr_2[VERT_PRED][13+i] = s14;
    img->mprr_2[VERT_PRED][14+i] = s15;
    img->mprr_2[VERT_PRED][15+i] = s16;
  } 
  *tot_intra_sad = IntraMB_Sad(img,imgY_org+img_offset,img->mprr_2[VERT_PRED]);
  *imode = VERT_PRED_16;
  

  for (i=0; i < 16; i++)
  {
    img->mprr_2[HOR_PRED][i]	 = ss1;
    img->mprr_2[HOR_PRED][16+i]  = ss2;
    img->mprr_2[HOR_PRED][32+i]  = ss3;
    img->mprr_2[HOR_PRED][48+i]  = ss4;
	img->mprr_2[HOR_PRED][64+i]	 = ss5;
    img->mprr_2[HOR_PRED][80+i]  = ss6;
    img->mprr_2[HOR_PRED][96+i]  = ss7;
    img->mprr_2[HOR_PRED][112+i] = ss8;
	img->mprr_2[HOR_PRED][128+i] = ss9;
    img->mprr_2[HOR_PRED][144+i] = ss10;
    img->mprr_2[HOR_PRED][160+i] = ss11;
    img->mprr_2[HOR_PRED][176+i] = ss12;
	img->mprr_2[HOR_PRED][192+i] = ss13;
    img->mprr_2[HOR_PRED][208+i] = ss14;
    img->mprr_2[HOR_PRED][224+i] = ss15;
    img->mprr_2[HOR_PRED][240+i] = ss16;
  }  
  current_intra_sad = IntraMB_Sad(img,imgY_org+img_offset,img->mprr_2[HOR_PRED]);
  if( current_intra_sad < (*tot_intra_sad))
  {
	  *tot_intra_sad = current_intra_sad;
	  *imode = HOR_PRED_16;
  }

  ///////////////////////////////
  // make DC prediction
  ///////////////////////////////
    // left edge
  s0 = (ss1 +ss2 +ss3 +ss4 +ss5 +ss6 +ss7 +ss8 +ss9 +ss10 +ss11 +ss12 +ss13 +ss14 +ss15 +ss16 
	  +s1 +s2 +s3 +s4 +s5 +s6 +s7 +s8 +s9 +s10 +s11 +s12 +s13 +s14 +s15 +s16+16)>>5;                
  for (j=0; j < 256; j+=16)
  {
      img->mprr_2[DC_PRED][j]	= s0;		img->mprr_2[DC_PRED][j+1] = s0;
      img->mprr_2[DC_PRED][j+2] = s0;		img->mprr_2[DC_PRED][j+3] = s0;
	  img->mprr_2[DC_PRED][j+4] = s0;		img->mprr_2[DC_PRED][j+5] = s0;
      img->mprr_2[DC_PRED][j+6] = s0;		img->mprr_2[DC_PRED][j+7] = s0;
	  img->mprr_2[DC_PRED][j+8] = s0;		img->mprr_2[DC_PRED][j+9] = s0;
      img->mprr_2[DC_PRED][j+10] = s0;		img->mprr_2[DC_PRED][j+11] = s0;
	  img->mprr_2[DC_PRED][j+12] = s0;		img->mprr_2[DC_PRED][j+13] = s0;
      img->mprr_2[DC_PRED][j+14] = s0;		img->mprr_2[DC_PRED][j+15] = s0;
  }
  current_intra_sad = IntraMB_Sad(img,imgY_org+img_offset,img->mprr_2[DC_PRED]);
  if( current_intra_sad < (*tot_intra_sad))
  {
	  *tot_intra_sad = current_intra_sad;
	  *imode = DC_PRED_16;
  }

  /*plane predict*/
  ih=0;
  iv=0;
  temp=(img_y-1)*width+img_x;
  for (i=1;i<9;i++)
  {
    if (i<8)
      ih += i*(imgY[temp+7+i] - imgY[temp+7-i]);
    else
      ih += i*(imgY[temp+7+i] - imgY[temp-1]);
    
    iv += i*(imgY[(img_y+7+i)*width+img_x-1] - imgY[(img_y+7-i)*width+img_x-1]);
  }
  ib=(5*ih+32)>>6;
  ic=(5*iv+32)>>6;
  
  iaa=16*(imgY[(img_y-1)*width+img_x+15]+imgY[(img_y+15)*width+img_x-1]);

  for (j=0;j< MB_BLOCK_SIZE;j++)
  {
    for (i=0;i< MB_BLOCK_SIZE;i++)
    {
      img->mprr_2[PLANE_16][j*16+i]=
		  max(0,min(255,(iaa+(i-7)*ib +(j-7)*ic + 16)>>5));// store plane prediction
    }
  }
  current_intra_sad = IntraMB_Sad(img,imgY_org+img_offset,img->mprr_2[PLANE_16]);
  if( current_intra_sad < (*tot_intra_sad))
  {
	  *tot_intra_sad = current_intra_sad;
	  *imode = PLANE_16;
  }
  return *tot_intra_sad; 
}

int intrapred_luma_other(struct img_par *img,int img_x,int img_y,int *tot_intra_sad,int block_num)
{
  int i,j,s0;
  int pa,pb,pc,pd,pe,pf,pg,ph,pi,pj,pk,pl,px;
  int pic_block_x=img_x>>2;
  int pic_block_y=img_y>>2;
  int block_x=img_x&15;
  int block_y=img_y&15;
  int width=img->width+IMG_PAD_SIZE;
  int best_intra_sad;
  int upMode,leftMode,mostProbableMode,best_ipmode,ipmode;
  double lambda_mode = QP2QUANT[max(0,img->qp-SHIFT_QP)];
  int nonzero;
  int img_offset = img_y*width+img_x;
  int temp = img_offset-width;
  int current_intra_sad;

  	  pa=imgY[temp];
	  pb=imgY[temp+1];
	  pc=imgY[temp+2];
	  pd=imgY[temp+3];

	  pe=imgY[temp+4];
	  pf=imgY[temp+5];
	  pg=imgY[temp+6];
	  ph=imgY[temp+7];

	  px=imgY[temp-1]; temp +=width;
	  pi=imgY[temp-1]; temp +=width;
	  pj=imgY[temp-1]; temp +=width;
	  pk=imgY[temp-1]; temp +=width;
	  pl=imgY[temp-1];
  
  ///////////////////////////////
  // make DC prediction
  ///////////////////////////////
    s0 = (pa + pb + pc + pd + pi + pj + pk + pl + 4)>>3;

  for (j=0; j < BLOCK_SIZE; j++)
  {
  	i=j*4;
      img->mprr[DC_PRED][i] = s0;
      img->mprr[DC_PRED][i+1] = s0;
      img->mprr[DC_PRED][i+2] = s0;
      img->mprr[DC_PRED][i+3] = s0;
  }

  ///////////////////////////////
  // make horiz and vert prediction
  ///////////////////////////////

  for (i=0; i < BLOCK_SIZE; i++)
  {
    img->mprr[VERT_PRED][i*4] = pa;
    img->mprr[VERT_PRED][i*4+1] = pb;
    img->mprr[VERT_PRED][i*4+2] = pc;
    img->mprr[VERT_PRED][i*4+3] = pd;
    img->mprr[HOR_PRED][i]  = pi;
    img->mprr[HOR_PRED][4+i]  = pj;
    img->mprr[HOR_PRED][8+i]  = pk;
    img->mprr[HOR_PRED][12+i]  = pl;
  }

    // Mode DIAG_DOWN_LEFT_PRED
    img->mprr[DIAG_DOWN_LEFT_PRED][0] = (pa + pc + (pb<<1) + 2) >>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][1] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][4] = (pb + pd + (pc<<1) + 2) >>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][2] =
    img->mprr[DIAG_DOWN_LEFT_PRED][5] =
    img->mprr[DIAG_DOWN_LEFT_PRED][8] = (pc + pe + (pd<<1) + 2) >>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][3] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][6] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][9] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][12] = (pd + pf + (pe<<1) + 2) >>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][7] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][10] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][13] = (pe + pg + (pf<<1) + 2) >>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][11] = 
    img->mprr[DIAG_DOWN_LEFT_PRED][14] = (pf + ph + (pg<<1) + 2) >>2;
    img->mprr[DIAG_DOWN_LEFT_PRED][15] = (pg + 3*(ph) + 2) >>2;

    // Mode VERT_LEFT_PRED
    img->mprr[VERT_LEFT_PRED][0] = (pa + pb + 1) >>1;
    img->mprr[VERT_LEFT_PRED][1] = 
    img->mprr[VERT_LEFT_PRED][8] = (pb + pc + 1) >>1;
    img->mprr[VERT_LEFT_PRED][2] = 
    img->mprr[VERT_LEFT_PRED][9] = (pc + pd + 1) >>1;
    img->mprr[VERT_LEFT_PRED][3] = 
    img->mprr[VERT_LEFT_PRED][10] = (pd + pe + 1) >>1;
    img->mprr[VERT_LEFT_PRED][11] = (pe + pf + 1) >>1;
    img->mprr[VERT_LEFT_PRED][4] = (pa + (pb<<1) + pc + 2) >>2;
    img->mprr[VERT_LEFT_PRED][5] = 
    img->mprr[VERT_LEFT_PRED][12] = (pb + (pc<<1) + pd + 2) >>2;
    img->mprr[VERT_LEFT_PRED][6] = 
    img->mprr[VERT_LEFT_PRED][13] = (pc + (pd<<1) + pe + 2) >>2;
    img->mprr[VERT_LEFT_PRED][7] = 
    img->mprr[VERT_LEFT_PRED][14] = (pd + (pe<<1) + pf + 2) >>2;
    img->mprr[VERT_LEFT_PRED][15] = (pe + (pf<<1) + pg + 2) >>2;

     // Mode HOR_UP_PRED
    img->mprr[HOR_UP_PRED][0] = (pi + pj + 1) >>1;
    img->mprr[HOR_UP_PRED][1] = (pi + (pj<<1) + pk + 2) >>2;
    img->mprr[HOR_UP_PRED][2] = 
    img->mprr[HOR_UP_PRED][4] = (pj + pk + 1) >>1;
    img->mprr[HOR_UP_PRED][3] = 
    img->mprr[HOR_UP_PRED][5] = (pj + (pk<<1) + pl + 2) >>2;
    img->mprr[HOR_UP_PRED][6] = 
    img->mprr[HOR_UP_PRED][8] = (pk + pl + 1) >>1;
    img->mprr[HOR_UP_PRED][7] = 
    img->mprr[HOR_UP_PRED][9] = (pk + (pl<<1) + pl + 2) >>2;
    img->mprr[HOR_UP_PRED][12] = 
    img->mprr[HOR_UP_PRED][10] = 
    img->mprr[HOR_UP_PRED][11] = 
    img->mprr[HOR_UP_PRED][13] = 
    img->mprr[HOR_UP_PRED][14] = 
    img->mprr[HOR_UP_PRED][15] = pl;

    // Mode DIAG_DOWN_RIGHT_PRED
    img->mprr[DIAG_DOWN_RIGHT_PRED][12] = (pl + (pk<<1) + pj + 2) >>2;
    img->mprr[DIAG_DOWN_RIGHT_PRED][8] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][13] = (pk + (pj<<1) + pi + 2) >>2;
    img->mprr[DIAG_DOWN_RIGHT_PRED][4] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][9] = 
    img->mprr[DIAG_DOWN_RIGHT_PRED][14] = (pj + (pi<<1) + px + 2) >>2;
    img->mprr[DIAG_DOWN_RIGHT_PRED][0] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][5] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][10] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][15] = (pi + (px<<1) + pa + 2) >>2;
    img->mprr[DIAG_DOWN_RIGHT_PRED][1] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][6] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][11] = (px + (pa<<1) + pb + 2) >>2;
    img->mprr[DIAG_DOWN_RIGHT_PRED][2] =
    img->mprr[DIAG_DOWN_RIGHT_PRED][7] = (pa + (pb<<1) + pc + 2) >>2;
    img->mprr[DIAG_DOWN_RIGHT_PRED][3] = (pb + (pc<<1) + pd + 2) >>2;

     // Mode VERT_RIGHT_PRED
    img->mprr[VERT_RIGHT_PRED][0] = 
    img->mprr[VERT_RIGHT_PRED][9] = (px + pa + 1) >>1;
    img->mprr[VERT_RIGHT_PRED][1] = 
    img->mprr[VERT_RIGHT_PRED][10] = (pa + pb + 1) >>1;
    img->mprr[VERT_RIGHT_PRED][2] = 
    img->mprr[VERT_RIGHT_PRED][11] = (pb + pc + 1) >>1;
    img->mprr[VERT_RIGHT_PRED][3] = (pc + pd + 1) >>1;
    img->mprr[VERT_RIGHT_PRED][4] = 
    img->mprr[VERT_RIGHT_PRED][13] = (pi + (px<<1) + pa + 2) >>2;
    img->mprr[VERT_RIGHT_PRED][5] = 
    img->mprr[VERT_RIGHT_PRED][14] = (px + (pa<<1) + pb + 2) >>2;
    img->mprr[VERT_RIGHT_PRED][6] = 
    img->mprr[VERT_RIGHT_PRED][15] = (pa + (pb<<1) + pc + 2) >>2;
    img->mprr[VERT_RIGHT_PRED][7] = (pb + (pc<<1) + pd + 2) >>2;
    img->mprr[VERT_RIGHT_PRED][8] = (px + (pi<<1) + pj + 2) >>2;
    img->mprr[VERT_RIGHT_PRED][12] = (pi + (pj<<1) + pk + 2) >>2;

    // Mode HOR_DOWN_PRED
    img->mprr[HOR_DOWN_PRED][0] = 
    img->mprr[HOR_DOWN_PRED][6] = (px + pi + 1) >>1;
    img->mprr[HOR_DOWN_PRED][1] = 
    img->mprr[HOR_DOWN_PRED][7] = (pi + (px<<1) + pa + 2) >>2;
    img->mprr[HOR_DOWN_PRED][2] = (px + (pa<<1) + pb + 2) >>2;
    img->mprr[HOR_DOWN_PRED][3] = (pa + (pb<<1) + pc + 2) >>2;
    img->mprr[HOR_DOWN_PRED][4] = 
    img->mprr[HOR_DOWN_PRED][10] = (pi + pj + 1) >>1;
    img->mprr[HOR_DOWN_PRED][5] = 
    img->mprr[HOR_DOWN_PRED][11] = (px + (pi<<1) + pj + 2) >>2;
    img->mprr[HOR_DOWN_PRED][8] = 
    img->mprr[HOR_DOWN_PRED][14] = (pj + pk + 1) >>1;
    img->mprr[HOR_DOWN_PRED][9] = 
    img->mprr[HOR_DOWN_PRED][15] = (pi + (pj<<1) + pk + 2) >>2;
    img->mprr[HOR_DOWN_PRED][12] = (pk + pl + 1) >>1;
    img->mprr[HOR_DOWN_PRED][13] = (pj + (pk<<1) + pl + 2) >>2;
    
    best_intra_sad=MAX_VALUE; 		  
    upMode = img->ipredmode[pic_block_x+1][pic_block_y];
    leftMode = img->ipredmode[pic_block_x][pic_block_y+1];
    mostProbableMode  = (upMode < 0 || leftMode < 0) ? DC_PRED : upMode < leftMode ? upMode : leftMode;
    for (ipmode=0; ipmode < NO_INTRA_PMODE; ipmode++)
    {
		current_intra_sad  = (ipmode == mostProbableMode) ? 0 : (int)floor(4 * lambda_mode );			  
        current_intra_sad += Intra_Sad(img,imgY_org+img_offset,img->mprr[ipmode]);        
        if (current_intra_sad < best_intra_sad) 
        {
           best_intra_sad=current_intra_sad;
           best_ipmode=ipmode;
        }      
    }
    *tot_intra_sad += best_intra_sad;
    img->ipredmode[pic_block_x+1][pic_block_y+1]=best_ipmode;
    img->intra_pred_modes[block_num] = mostProbableMode == best_ipmode ? -1 : best_ipmode < mostProbableMode ? best_ipmode : best_ipmode-1;
		                            
    nonzero = dct_luma(imgY_org+img_offset,img->mprr[best_ipmode],block_x,block_y,img);     
  return nonzero;
}

int macroblock_intra_topleft(struct img_par *img)
{
  int cbp,tmp=0;                
  int tot_intra_sad,tot_intra_sad1,cost=0; 
  int imode=2;/*yummy*/
          
  img->imod = INTRA_MB_OLD; 
  cbp=0;
  tot_intra_sad = tot_intra_sad1 = QP2QUANT[img->qp-SHIFT_QP]*24;
  img->i16offset = 0;/*yummy*/
  
  tmp|=intrapred_luma_topleft(img,img->pix_x,img->pix_y,&tot_intra_sad,0);
  tmp|=intrapred_luma_top(img,img->pix_x+4,img->pix_y,&tot_intra_sad,1);
  tmp|=intrapred_luma_left(img,img->pix_x,img->pix_y+4,&tot_intra_sad,2);
  tmp|=intrapred_luma_noright(img,img->pix_x+4,img->pix_y+4,&tot_intra_sad,3);
  cbp=tmp;tmp=0;
  
  tmp|=intrapred_luma_top(img,img->pix_x+8,img->pix_y,&tot_intra_sad,4);
  tmp|=intrapred_luma_top(img,img->pix_x+12,img->pix_y,&tot_intra_sad,5);
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y+4,&tot_intra_sad,6);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y+4,&tot_intra_sad,7);
  cbp|=(tmp<<1);tmp=0;
  
  tmp|=intrapred_luma_left(img,img->pix_x,img->pix_y+8,&tot_intra_sad,8);
  tmp|=intrapred_luma_other(img,img->pix_x+4,img->pix_y+8,&tot_intra_sad,9);
  tmp|=intrapred_luma_left(img,img->pix_x,img->pix_y+12,&tot_intra_sad,10);
  tmp|=intrapred_luma_noright(img,img->pix_x+4,img->pix_y+12,&tot_intra_sad,11);
  cbp|=(tmp<<2);tmp=0;
  
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y+8,&tot_intra_sad,12);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y+8,&tot_intra_sad,13);
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y+12,&tot_intra_sad,14);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y+12,&tot_intra_sad,15);
  cbp|=(tmp<<3);
  img->cbp=cbp;
  
  /*yummy*/
/*  cost = intrapred_lumaMB_topleft(img,img->pix_x,img->pix_y,&cost,&imode);
  if(cost<tot_intra_sad)
  {	  
	  tot_intra_sad = cost;
	  img->imod = INTRA_MB_NEW;
	  img->cbp = dct_luma_16x16 (imgY_org, imode, img);
	  img->i16offset = imode;

	  img->ipredmode[1][1]=DC_PRED;  img->ipredmode[1][2]=DC_PRED;
	  img->ipredmode[1][3]=DC_PRED;  img->ipredmode[1][4]=DC_PRED;
	  img->ipredmode[2][1]=DC_PRED;  img->ipredmode[2][2]=DC_PRED;
	  img->ipredmode[2][3]=DC_PRED;  img->ipredmode[2][4]=DC_PRED;
	  img->ipredmode[3][1]=DC_PRED;  img->ipredmode[3][2]=DC_PRED;
	  img->ipredmode[3][3]=DC_PRED;  img->ipredmode[3][4]=DC_PRED;
	  img->ipredmode[4][1]=DC_PRED;  img->ipredmode[4][2]=DC_PRED;
	  img->ipredmode[4][3]=DC_PRED;  img->ipredmode[4][4]=DC_PRED;

	  img->intra_pred_modes[0] = img->intra_pred_modes[1] =DC_PRED;
	  img->intra_pred_modes[2] = img->intra_pred_modes[3] =DC_PRED;
	  img->intra_pred_modes[4] = img->intra_pred_modes[5] =DC_PRED;
	  img->intra_pred_modes[6] = img->intra_pred_modes[7] =DC_PRED;
	  img->intra_pred_modes[8] = img->intra_pred_modes[9] =DC_PRED;
	  img->intra_pred_modes[10]= img->intra_pred_modes[11]=DC_PRED;
	  img->intra_pred_modes[12]= img->intra_pred_modes[13]=DC_PRED;
	  img->intra_pred_modes[14]= img->intra_pred_modes[15]=DC_PRED;
  }*/
  return tot_intra_sad;
}

int macroblock_intra_top(struct img_par *img)
{
  int cbp,tmp=0;                
  int tot_intra_sad, cost = 0;  
  int imode = 2;		/*yummy*/
  int block_x, block_y; /*yummy*/
          
  img->imod = INTRA_MB_OLD; 
  cbp=0;
  tot_intra_sad=QP2QUANT[img->qp-SHIFT_QP]*24;
  img->i16offset = 0;		/*yummy*/
  block_x = img->pix_x>>2;	/*yummy*/
  block_y = img->pix_y>>2;	/*yummy*/
  
  tmp|=intrapred_luma_top(img,img->pix_x,img->pix_y,&tot_intra_sad,0);
  tmp|=intrapred_luma_top(img,img->pix_x+4,img->pix_y,&tot_intra_sad,1);
  tmp|=intrapred_luma_other(img,img->pix_x,img->pix_y+4,&tot_intra_sad,2);
  tmp|=intrapred_luma_noright(img,img->pix_x+4,img->pix_y+4,&tot_intra_sad,3);
  cbp=tmp;tmp=0;
  
  tmp|=intrapred_luma_top(img,img->pix_x+8,img->pix_y,&tot_intra_sad,4);
  tmp|=intrapred_luma_top(img,img->pix_x+12,img->pix_y,&tot_intra_sad,5);
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y+4,&tot_intra_sad,6);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y+4,&tot_intra_sad,7);
  cbp|=(tmp<<1);tmp=0;
  
  tmp|=intrapred_luma_other(img,img->pix_x,img->pix_y+8,&tot_intra_sad,8);
  tmp|=intrapred_luma_other(img,img->pix_x+4,img->pix_y+8,&tot_intra_sad,9);
  tmp|=intrapred_luma_other(img,img->pix_x,img->pix_y+12,&tot_intra_sad,10);
  tmp|=intrapred_luma_noright(img,img->pix_x+4,img->pix_y+12,&tot_intra_sad,11);
  cbp|=(tmp<<2);tmp=0;
  
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y+8,&tot_intra_sad,12);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y+8,&tot_intra_sad,13);
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y+12,&tot_intra_sad,14);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y+12,&tot_intra_sad,15);
  cbp|=(tmp<<3);
  img->cbp=cbp;

  /*yummy*/
/*  cost = intrapred_lumaMB_top(img,img->pix_x,img->pix_y,&cost,&imode);
  if(cost<tot_intra_sad)
  {	  
	  tot_intra_sad = cost;
	  img->imod = INTRA_MB_NEW;
	  img->cbp = dct_luma_16x16 (imgY_org+img->pix_y*(img->width+IMG_PAD_SIZE)+img->pix_x, imode, img);
	  img->i16offset = imode;

	  img->ipredmode[block_x+1][block_y+1]=DC_PRED;  img->ipredmode[block_x+1][block_y+2]=DC_PRED;
	  img->ipredmode[block_x+1][block_y+3]=DC_PRED;  img->ipredmode[block_x+1][block_y+4]=DC_PRED;
	  img->ipredmode[block_x+2][block_y+1]=DC_PRED;  img->ipredmode[block_x+2][block_y+2]=DC_PRED;
	  img->ipredmode[block_x+2][block_y+3]=DC_PRED;  img->ipredmode[block_x+2][block_y+4]=DC_PRED;
	  img->ipredmode[block_x+3][block_y+1]=DC_PRED;  img->ipredmode[block_x+3][block_y+2]=DC_PRED;
	  img->ipredmode[block_x+3][block_y+3]=DC_PRED;  img->ipredmode[block_x+3][block_y+4]=DC_PRED;
	  img->ipredmode[block_x+4][block_y+1]=DC_PRED;  img->ipredmode[block_x+4][block_y+2]=DC_PRED;
	  img->ipredmode[block_x+4][block_y+3]=DC_PRED;  img->ipredmode[block_x+4][block_y+4]=DC_PRED;

	  img->intra_pred_modes[0] = img->intra_pred_modes[1] =DC_PRED;
	  img->intra_pred_modes[2] = img->intra_pred_modes[3] =DC_PRED;
	  img->intra_pred_modes[4] = img->intra_pred_modes[5] =DC_PRED;
	  img->intra_pred_modes[6] = img->intra_pred_modes[7] =DC_PRED;
	  img->intra_pred_modes[8] = img->intra_pred_modes[9] =DC_PRED;
	  img->intra_pred_modes[10]= img->intra_pred_modes[11]=DC_PRED;
	  img->intra_pred_modes[12]= img->intra_pred_modes[13]=DC_PRED;
	  img->intra_pred_modes[14]= img->intra_pred_modes[15]=DC_PRED;
  }*/
  return tot_intra_sad;
}

int macroblock_intra_left(struct img_par *img)
{
  int cbp,tmp=0;                
  int tot_intra_sad;
  int imode = 0, cost = 0;	/*yummy*/
  int block_x, block_y;		/*yummy*/
  block_x = img->pix_x>>2;	/*yummy*/
  block_y = img->pix_y>>2;	/*yummy*/
          
  img->imod = INTRA_MB_OLD; 
  cbp=0;
  tot_intra_sad=QP2QUANT[img->qp-SHIFT_QP]*24;  
  img->i16offset = 0;		/*yummy*/
  
  tmp|=intrapred_luma_left(img,img->pix_x,img->pix_y,&tot_intra_sad,0);
  tmp|=intrapred_luma_other(img,img->pix_x+4,img->pix_y,&tot_intra_sad,1);
  tmp|=intrapred_luma_left(img,img->pix_x,img->pix_y+4,&tot_intra_sad,2);
  tmp|=intrapred_luma_noright(img,img->pix_x+4,img->pix_y+4,&tot_intra_sad,3);
  cbp=tmp;tmp=0;
  
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y,&tot_intra_sad,4);
  tmp|=intrapred_luma_other(img,img->pix_x+12,img->pix_y,&tot_intra_sad,5);
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y+4,&tot_intra_sad,6);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y+4,&tot_intra_sad,7);
  cbp|=(tmp<<1);tmp=0;
  
  tmp|=intrapred_luma_left(img,img->pix_x,img->pix_y+8,&tot_intra_sad,8);
  tmp|=intrapred_luma_other(img,img->pix_x+4,img->pix_y+8,&tot_intra_sad,9);
  tmp|=intrapred_luma_left(img,img->pix_x,img->pix_y+12,&tot_intra_sad,10);
  tmp|=intrapred_luma_noright(img,img->pix_x+4,img->pix_y+12,&tot_intra_sad,11);
  cbp|=(tmp<<2);tmp=0;
  
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y+8,&tot_intra_sad,12);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y+8,&tot_intra_sad,13);
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y+12,&tot_intra_sad,14);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y+12,&tot_intra_sad,15);
  cbp|=(tmp<<3);
  img->cbp=cbp;

  /*yummy*/
/*  cost = intrapred_lumaMB_left(img,img->pix_x,img->pix_y,&cost,&imode);
  if(cost<tot_intra_sad)
  {	  
	  tot_intra_sad = cost;
	  img->imod = INTRA_MB_NEW;
	  img->cbp = dct_luma_16x16 (imgY_org+img->pix_y*(img->width+IMG_PAD_SIZE)+img->pix_x, imode, img);
	  img->i16offset = imode;

	  img->ipredmode[block_x+1][block_y+1]=DC_PRED;  img->ipredmode[block_x+1][block_y+2]=DC_PRED;
	  img->ipredmode[block_x+1][block_y+3]=DC_PRED;  img->ipredmode[block_x+1][block_y+4]=DC_PRED;
	  img->ipredmode[block_x+2][block_y+1]=DC_PRED;  img->ipredmode[block_x+2][block_y+2]=DC_PRED;
	  img->ipredmode[block_x+2][block_y+3]=DC_PRED;  img->ipredmode[block_x+2][block_y+4]=DC_PRED;
	  img->ipredmode[block_x+3][block_y+1]=DC_PRED;  img->ipredmode[block_x+3][block_y+2]=DC_PRED;
	  img->ipredmode[block_x+3][block_y+3]=DC_PRED;  img->ipredmode[block_x+3][block_y+4]=DC_PRED;
	  img->ipredmode[block_x+4][block_y+1]=DC_PRED;  img->ipredmode[block_x+4][block_y+2]=DC_PRED;
	  img->ipredmode[block_x+4][block_y+3]=DC_PRED;  img->ipredmode[block_x+4][block_y+4]=DC_PRED;

	  img->intra_pred_modes[0] = img->intra_pred_modes[1] =DC_PRED;
	  img->intra_pred_modes[2] = img->intra_pred_modes[3] =DC_PRED;
	  img->intra_pred_modes[4] = img->intra_pred_modes[5] =DC_PRED;
	  img->intra_pred_modes[6] = img->intra_pred_modes[7] =DC_PRED;
	  img->intra_pred_modes[8] = img->intra_pred_modes[9] =DC_PRED;
	  img->intra_pred_modes[10]= img->intra_pred_modes[11]=DC_PRED;
	  img->intra_pred_modes[12]= img->intra_pred_modes[13]=DC_PRED;
	  img->intra_pred_modes[14]= img->intra_pred_modes[15]=DC_PRED;
  }  */
  return tot_intra_sad;
}

int macroblock_intra_right(struct img_par *img)
{
  int cbp,tmp=0;                
  int tot_intra_sad;  
  int imode = 0, cost =0;	/*yummy*/
  int block_x, block_y;		/*yummy*/  
  block_x = img->pix_x>>2;	/*yummy*/
  block_y = img->pix_y>>2;	/*yummy*/
          
  img->imod = INTRA_MB_OLD; 
  cbp=0;
  tot_intra_sad=QP2QUANT[img->qp-SHIFT_QP]*24;
  img->i16offset = 0;		/*yummy*/
  
  tmp|=intrapred_luma_other(img,img->pix_x,img->pix_y,&tot_intra_sad,0);
  tmp|=intrapred_luma_other(img,img->pix_x+4,img->pix_y,&tot_intra_sad,1);
  tmp|=intrapred_luma_other(img,img->pix_x,img->pix_y+4,&tot_intra_sad,2);
  tmp|=intrapred_luma_noright(img,img->pix_x+4,img->pix_y+4,&tot_intra_sad,3);
  cbp=tmp;tmp=0;
  
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y,&tot_intra_sad,4);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y,&tot_intra_sad,5);
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y+4,&tot_intra_sad,6);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y+4,&tot_intra_sad,7);
  cbp|=(tmp<<1);tmp=0;
  
  tmp|=intrapred_luma_other(img,img->pix_x,img->pix_y+8,&tot_intra_sad,8);
  tmp|=intrapred_luma_other(img,img->pix_x+4,img->pix_y+8,&tot_intra_sad,9);
  tmp|=intrapred_luma_other(img,img->pix_x,img->pix_y+12,&tot_intra_sad,10);
  tmp|=intrapred_luma_noright(img,img->pix_x+4,img->pix_y+12,&tot_intra_sad,11);
  cbp|=(tmp<<2);tmp=0;
  
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y+8,&tot_intra_sad,12);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y+8,&tot_intra_sad,13);
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y+12,&tot_intra_sad,14);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y+12,&tot_intra_sad,15);
  cbp|=(tmp<<3);
  img->cbp=cbp;

  /*yummy*/
/*  cost = intrapred_lumaMB_other(img,img->pix_x,img->pix_y,&cost,&imode);
  if(cost<tot_intra_sad)
  {  
	  img->imod = INTRA_MB_NEW;
	  tot_intra_sad = cost;
	  img->cbp = dct_luma_16x16 (imgY_org+img->pix_y*(img->width+IMG_PAD_SIZE)+img->pix_x, imode, img);
	  img->i16offset = imode;
	  
	  img->ipredmode[block_x+1][block_y+3]=DC_PRED;  img->ipredmode[block_x+1][block_y+4]=DC_PRED;
	  img->ipredmode[block_x+2][block_y+1]=DC_PRED;  img->ipredmode[block_x+2][block_y+2]=DC_PRED;
	  img->ipredmode[block_x+2][block_y+3]=DC_PRED;  img->ipredmode[block_x+2][block_y+4]=DC_PRED;
	  img->ipredmode[block_x+3][block_y+1]=DC_PRED;  img->ipredmode[block_x+3][block_y+2]=DC_PRED;
	  img->ipredmode[block_x+3][block_y+3]=DC_PRED;  img->ipredmode[block_x+3][block_y+4]=DC_PRED;
	  img->ipredmode[block_x+4][block_y+1]=DC_PRED;  img->ipredmode[block_x+4][block_y+2]=DC_PRED;
	  img->ipredmode[block_x+4][block_y+3]=DC_PRED;  img->ipredmode[block_x+4][block_y+4]=DC_PRED;

	  img->intra_pred_modes[0] = img->intra_pred_modes[1] =DC_PRED;
	  img->intra_pred_modes[2] = img->intra_pred_modes[3] =DC_PRED;
	  img->intra_pred_modes[4] = img->intra_pred_modes[5] =DC_PRED;
	  img->intra_pred_modes[6] = img->intra_pred_modes[7] =DC_PRED;
	  img->intra_pred_modes[8] = img->intra_pred_modes[9] =DC_PRED;
	  img->intra_pred_modes[10]= img->intra_pred_modes[11]=DC_PRED;
	  img->intra_pred_modes[12]= img->intra_pred_modes[13]=DC_PRED;
	  img->intra_pred_modes[14]= img->intra_pred_modes[15]=DC_PRED;
  }*/
  return tot_intra_sad;
}

int macroblock_intra_other(struct img_par *img)
{
  int cbp,tmp=0;                
  int tot_intra_sad;  
  int imode = 0, cost = 0;	/*yummy*/
  int block_x, block_y;		/*yummy*/
  
  block_x = img->pix_x>>2;	/*yummy*/
  block_y = img->pix_y>>2;	/*yummy*/
          
  img->imod = INTRA_MB_OLD; 
  cbp=0;
  tot_intra_sad=QP2QUANT[img->qp-SHIFT_QP]*24;
  img->i16offset = 0;		/*yummy*/
  
  tmp|=intrapred_luma_other(img,img->pix_x,img->pix_y,&tot_intra_sad,0);
  tmp|=intrapred_luma_other(img,img->pix_x+4,img->pix_y,&tot_intra_sad,1);
  tmp|=intrapred_luma_other(img,img->pix_x,img->pix_y+4,&tot_intra_sad,2);
  tmp|=intrapred_luma_noright(img,img->pix_x+4,img->pix_y+4,&tot_intra_sad,3);
  cbp=tmp;tmp=0;
  
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y,&tot_intra_sad,4);
  tmp|=intrapred_luma_other(img,img->pix_x+12,img->pix_y,&tot_intra_sad,5);
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y+4,&tot_intra_sad,6);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y+4,&tot_intra_sad,7);
  cbp|=(tmp<<1);tmp=0;
  
  tmp|=intrapred_luma_other(img,img->pix_x,img->pix_y+8,&tot_intra_sad,8);
  tmp|=intrapred_luma_other(img,img->pix_x+4,img->pix_y+8,&tot_intra_sad,9);
  tmp|=intrapred_luma_other(img,img->pix_x,img->pix_y+12,&tot_intra_sad,10);
  tmp|=intrapred_luma_noright(img,img->pix_x+4,img->pix_y+12,&tot_intra_sad,11);
  cbp|=(tmp<<2);tmp=0;
  
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y+8,&tot_intra_sad,12);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y+8,&tot_intra_sad,13);
  tmp|=intrapred_luma_other(img,img->pix_x+8,img->pix_y+12,&tot_intra_sad,14);
  tmp|=intrapred_luma_noright(img,img->pix_x+12,img->pix_y+12,&tot_intra_sad,15);
  cbp|=(tmp<<3);
  img->cbp=cbp;

  /*yummy*/
/*  cost = intrapred_lumaMB_other(img,img->pix_x,img->pix_y,&cost,&imode);
  if(cost<tot_intra_sad)
  {
	  tot_intra_sad = cost;
	  img->imod = INTRA_MB_NEW;
 	  img->cbp = dct_luma_16x16 (imgY_org+img->pix_y*(img->width+IMG_PAD_SIZE)+img->pix_x, imode, img);
	  img->i16offset = imode;

	  img->ipredmode[block_x+1][block_y+1]=DC_PRED;  img->ipredmode[block_x+1][block_y+2]=DC_PRED;
	  img->ipredmode[block_x+1][block_y+3]=DC_PRED;  img->ipredmode[block_x+1][block_y+4]=DC_PRED;
	  img->ipredmode[block_x+2][block_y+1]=DC_PRED;  img->ipredmode[block_x+2][block_y+2]=DC_PRED;
	  img->ipredmode[block_x+2][block_y+3]=DC_PRED;  img->ipredmode[block_x+2][block_y+4]=DC_PRED;
	  img->ipredmode[block_x+3][block_y+1]=DC_PRED;  img->ipredmode[block_x+3][block_y+2]=DC_PRED;
	  img->ipredmode[block_x+3][block_y+3]=DC_PRED;  img->ipredmode[block_x+3][block_y+4]=DC_PRED;
	  img->ipredmode[block_x+4][block_y+1]=DC_PRED;  img->ipredmode[block_x+4][block_y+2]=DC_PRED;
	  img->ipredmode[block_x+4][block_y+3]=DC_PRED;  img->ipredmode[block_x+4][block_y+4]=DC_PRED;

	  img->intra_pred_modes[0] = img->intra_pred_modes[1] =DC_PRED;
	  img->intra_pred_modes[2] = img->intra_pred_modes[3] =DC_PRED;
	  img->intra_pred_modes[4] = img->intra_pred_modes[5] =DC_PRED;
	  img->intra_pred_modes[6] = img->intra_pred_modes[7] =DC_PRED;
	  img->intra_pred_modes[8] = img->intra_pred_modes[9] =DC_PRED;
	  img->intra_pred_modes[10]= img->intra_pred_modes[11]=DC_PRED;
	  img->intra_pred_modes[12]= img->intra_pred_modes[13]=DC_PRED;
	  img->intra_pred_modes[14]= img->intra_pred_modes[15]=DC_PRED; 
  }*/
  return tot_intra_sad;
}

int Motion_Estimation(struct img_par *img,int tot_intra_sad)
{
	int mincost,tmpcost,smallblockcost;

	mincost=motion_search(img,tot_intra_sad);
	if(!img->bSkipMode && mincost>1024)
	{
		tmpcost=motion_search_16x8(img,mincost);
		if(tmpcost<mincost)
		{
			mincost=tmpcost;
			tmpcost=motion_search_8x16(img,mincost);
			
			if(tmpcost<mincost)
			{
				mincost=tmpcost;
				#ifdef SMALLBLOCK
				smallblockcost=SmallBlock_ME(img,mincost);
				if(mincost>smallblockcost)
				{
					img->mb_mode=5;
					mincost=smallblockcost;
					return mincost;
				}
				#endif
			}			
		}
	}
#ifdef SMALLBLOCK
	Copy_tmpmv(img);
#endif
	return mincost;
}

void macroblock_inter(struct img_par *img,int tot_intra_sad)
{
	int i,j;
	int cbp,cr_cbp=0;
	int cbptmp=0;
	int sum_cnt_nonz,coeff_cost;
	int *Lum=MbLum;
	int *LumTmp=MbLumTmp;
	byte *curr,*pre;
	int width=img->width+IMG_PAD_SIZE;
	int width_cr=img->width_cr+IMG_PAD_SIZE;
	int pic_block_x=img->block_x;
	int	pic_block_y=img->block_y;
	
    if (img->imod == INTRA_MB_INTER)
    {
		if(img->mb_mode==5)
		{
			macroblock_inter_SmallBlock(img);
			return;
		}
		for(i=0;i<4;i++)
		{
			img->ipredmode[pic_block_x+i+1][pic_block_y+1]=DC_PRED;
			img->ipredmode[pic_block_x+i+1][pic_block_y+2]=DC_PRED;
			img->ipredmode[pic_block_x+i+1][pic_block_y+3]=DC_PRED;
			img->ipredmode[pic_block_x+i+1][pic_block_y+4]=DC_PRED;
		}
    	if(img->mb_mode==1) Predict(img);
		else if(img->mb_mode==2) 
		{
			Predict_16x8(img, 0);
			Predict_16x8(img, 1);
		}
		else
		{
			Predict_8x16(img, 0);
			Predict_8x16(img, 1);
		}

    	cbp=0;
    	sum_cnt_nonz=0;
    	
    	coeff_cost=0;
    	cbptmp|=inter_dct_luma(Lum,   LumTmp   ,0,0,&coeff_cost,img);
    	cbptmp|=inter_dct_luma(Lum+4, LumTmp+16,4,0,&coeff_cost,img);
    	cbptmp|=inter_dct_luma(Lum+64,LumTmp+32,0,4,&coeff_cost,img);
    	cbptmp|=inter_dct_luma(Lum+68,LumTmp+48,4,4,&coeff_cost,img);
    	if (coeff_cost > _LUMA_COEFF_COST_) 
        {
        	cbp=cbptmp;
          sum_cnt_nonz += coeff_cost;
        }
        else //discard
        {
			curr= imgY+img->pix_y*width+img->pix_x;
			if(img->mb_mode==1)
			{
			  pre = ipol[img->comp]+img->offset;
			}
			else if(img->mb_mode==2)
			{
				  pre = ipol[img->comp1[0]]+img->offset1[0];
			}
			else
			{
				  pre = ipol[img->comp2[0]]+img->offset2[0];
			}

			for (i=0; i < 8; i++)
			{
          		j=i*width;
          		memcpy(curr+j,pre+j,8);
			}
			cbp_blk[pic_block_y  ][pic_block_x  ]=0;
			cbp_blk[pic_block_y  ][pic_block_x+1]=0;
			cbp_blk[pic_block_y+1][pic_block_x  ]=0;
			cbp_blk[pic_block_y+1][pic_block_x+1]=0;
        }
		cbptmp=0;
        Lum+=8;
        LumTmp+=64;
        
        coeff_cost=0;
    	cbptmp|=inter_dct_luma(Lum,   LumTmp   ,8, 0,&coeff_cost,img);
    	cbptmp|=inter_dct_luma(Lum+4, LumTmp+16,12,0,&coeff_cost,img);
    	cbptmp|=inter_dct_luma(Lum+64,LumTmp+32,8, 4,&coeff_cost,img);
    	cbptmp|=inter_dct_luma(Lum+68,LumTmp+48,12,4,&coeff_cost,img);
    	if (coeff_cost > _LUMA_COEFF_COST_) 
        {
        	cbp|=(cbptmp<<1);
          sum_cnt_nonz += coeff_cost;
        }
        else //discard
        {
			curr= imgY+img->pix_y*width+img->pix_x+8;
			if(img->mb_mode==1)
			{			  
			  pre = ipol[img->comp]+img->offset+8;
			}
			else if(img->mb_mode==2)
			{				
				  pre = ipol[img->comp1[0]]+img->offset1[0]+8;
				  
			}
			else
			{				
				  pre = ipol[img->comp2[1]]+img->offset2[1];
				  
			}

			for (i=0; i < 8; i++)
			{
          		j=i*width;
          		memcpy(curr+j,pre+j,8);
			}
			cbp_blk[pic_block_y  ][pic_block_x+2]=0;
			cbp_blk[pic_block_y  ][pic_block_x+3]=0;
			cbp_blk[pic_block_y+1][pic_block_x+2]=0;
			cbp_blk[pic_block_y+1][pic_block_x+3]=0;
        }
		cbptmp=0;
        Lum+=120;//128-8;
        LumTmp+=64;
        
        coeff_cost=0;
    	cbptmp|=inter_dct_luma(Lum,   LumTmp   ,0,8 ,&coeff_cost,img);
    	cbptmp|=inter_dct_luma(Lum+4, LumTmp+16,4,8 ,&coeff_cost,img);
    	cbptmp|=inter_dct_luma(Lum+64,LumTmp+32,0,12,&coeff_cost,img);
    	cbptmp|=inter_dct_luma(Lum+68,LumTmp+48,4,12,&coeff_cost,img);
    	if (coeff_cost > _LUMA_COEFF_COST_) 
        {
			cbp|=(cbptmp<<2);
			sum_cnt_nonz += coeff_cost;
        }
        else //discard
        {
			curr= imgY+img->pix_y*width+img->pix_x+8*width;
			if(img->mb_mode==1)
			{
			  pre = ipol[img->comp]+img->offset+8*width;
			}
			else if(img->mb_mode==2)
			{
				  pre = ipol[img->comp1[1]]+img->offset1[1];	  
			}
			else
			{
				  pre = ipol[img->comp2[0]]+img->offset2[0]+8*width;	  
			}

			for (i=0; i < 8; i++)
			{
          		j=i*width;
          		memcpy(curr+j,pre+j,8);
			}
			cbp_blk[pic_block_y+2][pic_block_x  ]=0;
			cbp_blk[pic_block_y+2][pic_block_x+1]=0;
			cbp_blk[pic_block_y+3][pic_block_x  ]=0;
			cbp_blk[pic_block_y+3][pic_block_x+1]=0;
        }
		cbptmp=0;
        Lum+=8;
        LumTmp+=64;
        
        coeff_cost=0;
    	cbptmp|=inter_dct_luma(Lum,   LumTmp   ,8 ,8 ,&coeff_cost,img);
    	cbptmp|=inter_dct_luma(Lum+4, LumTmp+16,12,8 ,&coeff_cost,img);
    	cbptmp|=inter_dct_luma(Lum+64,LumTmp+32,8 ,12,&coeff_cost,img);
    	cbptmp|=inter_dct_luma(Lum+68,LumTmp+48,12,12,&coeff_cost,img);
    	if (coeff_cost > _LUMA_COEFF_COST_) 
        {
			cbp|=(cbptmp<<3);
			sum_cnt_nonz += coeff_cost;
        }
        else //discard
        {
			curr= imgY+img->pix_y*width+img->pix_x+8*width+8;
			if(img->mb_mode==1)
			{
			  
			  pre = ipol[img->comp]+img->offset+8*width+8;
			  
			}
			else if(img->mb_mode==2)
			{				
				  pre = ipol[img->comp1[1]]+img->offset1[1]+8;				  
			}
			else
			{				
				  pre = ipol[img->comp2[1]]+img->offset2[1]+8*width;				  
			}

			for (i=0; i < 8; i++)
			{
          		j=i*width;
          		memcpy(curr+j,pre+j,8);
			}
			cbp_blk[pic_block_y+2][pic_block_x+2]=0;
			cbp_blk[pic_block_y+2][pic_block_x+3]=0;
			cbp_blk[pic_block_y+3][pic_block_x+2]=0;
			cbp_blk[pic_block_y+3][pic_block_x+3]=0;
        }
        
        if (sum_cnt_nonz <= 5 ) 
		{
			  cbp=cbp & 48; // mask bit 4 and 5
			  if(img->mb_mode==1)
			  {
				  curr= imgY+img->pix_y*width+img->pix_x;
				  pre = ipol[img->comp]+img->offset;
				  for (i=0; i < 16; i++)
				  {
	      			j=i*width;
	       			memcpy(curr+j,pre+j,16);
				  }
			  }
			  else if(img->mb_mode==2)
			  {
				  curr= imgY+img->pix_y*width+img->pix_x;
				  pre = ipol[img->comp1[0]]+img->offset1[0];
				  for (i=0; i < 8; i++)
				  {
	      			j=i*width;
	       			memcpy(curr+j,pre+j,16);
				  }
				  curr= imgY+img->pix_y*width+img->pix_x+8*width;
				  pre = ipol[img->comp1[1]]+img->offset1[1];
				  for (i=0; i < 8; i++)
				  {
	      			j=i*width;
	       			memcpy(curr+j,pre+j,16);
				  }
			  }
			  else
			  {
				  curr= imgY+img->pix_y*width+img->pix_x;
				  pre = ipol[img->comp2[0]]+img->offset2[0];
				  for (i=0; i < 16; i++)
				  {
	      			j=i*width;
	       			memcpy(curr+j,pre+j,8);
				  }
				  curr= imgY+img->pix_y*width+img->pix_x+8;
				  pre = ipol[img->comp2[1]]+img->offset2[1];
				  for (i=0; i < 16; i++)
				  {
	      			j=i*width;
	       			memcpy(curr+j,pre+j,8);
				  }
			  }
				cbp_blk[pic_block_y  ][pic_block_x  ]=0;
				cbp_blk[pic_block_y  ][pic_block_x+1]=0;
				cbp_blk[pic_block_y  ][pic_block_x+2]=0;
				cbp_blk[pic_block_y  ][pic_block_x+3]=0;
				cbp_blk[pic_block_y+1][pic_block_x  ]=0;
				cbp_blk[pic_block_y+1][pic_block_x+1]=0;
				cbp_blk[pic_block_y+1][pic_block_x+2]=0;
				cbp_blk[pic_block_y+1][pic_block_x+3]=0;
				cbp_blk[pic_block_y+2][pic_block_x  ]=0;
				cbp_blk[pic_block_y+2][pic_block_x+1]=0;
				cbp_blk[pic_block_y+2][pic_block_x+2]=0;
				cbp_blk[pic_block_y+2][pic_block_x+3]=0;
				cbp_blk[pic_block_y+3][pic_block_x  ]=0;
				cbp_blk[pic_block_y+3][pic_block_x+1]=0;
				cbp_blk[pic_block_y+3][pic_block_x+2]=0;
				cbp_blk[pic_block_y+3][pic_block_x+3]=0;
		}
	
		if(cbp&1)
		{
			LumTmp=MbLumTmp;
			if(img->mb_mode==1) pre = ipol[img->comp]+img->offset;
			else if(img->mb_mode==2) pre = ipol[img->comp1[0]]+img->offset1[0];
			else pre = ipol[img->comp2[0]]+img->offset2[0];
			inter_idct_luma(LumTmp   ,pre   ,0,0,img,width);
			inter_idct_luma(LumTmp+16,pre+4 ,4,0,img,width);
			inter_idct_luma(LumTmp+32,pre+4*width,0,4,img,width);
			inter_idct_luma(LumTmp+48,pre+4*width+4,4,4,img,width);
		}
		if(cbp&2)
		{
			LumTmp=MbLumTmp+64;
			if(img->mb_mode==1) pre = ipol[img->comp]+img->offset+8;
			else if(img->mb_mode==2) pre = ipol[img->comp1[0]]+img->offset1[0]+8;
			else pre = ipol[img->comp2[1]]+img->offset2[1];
			inter_idct_luma(LumTmp   ,pre   ,8 ,0,img,width);
			inter_idct_luma(LumTmp+16,pre+4 ,12,0,img,width);
			inter_idct_luma(LumTmp+32,pre+4*width,8 ,4,img,width);
			inter_idct_luma(LumTmp+48,pre+4*width+4,12,4,img,width);
		}
		if(cbp&4)
		{
			LumTmp=MbLumTmp+128;
			if(img->mb_mode==1) pre = ipol[img->comp]+img->offset+8*width;
			else if(img->mb_mode==2) pre = ipol[img->comp1[1]]+img->offset1[1];
			else pre = ipol[img->comp2[0]]+img->offset2[0]+8*width;
			inter_idct_luma(LumTmp   ,pre   ,0,8 ,img,width);
			inter_idct_luma(LumTmp+16,pre+4 ,4,8 ,img,width);
			inter_idct_luma(LumTmp+32,pre+4*width,0,12,img,width);
			inter_idct_luma(LumTmp+48,pre+4*width+4,4,12,img,width);
		}
		if(cbp&8)
		{
			LumTmp=MbLumTmp+192;
			if(img->mb_mode==1) pre = ipol[img->comp]+img->offset+8*width+8;
			else if(img->mb_mode==2) pre = ipol[img->comp1[1]]+img->offset1[1]+8;
			else pre = ipol[img->comp2[1]]+img->offset2[1]+8*width;
			inter_idct_luma(LumTmp   ,pre   ,8 ,8 ,img,width);
			inter_idct_luma(LumTmp+16,pre+4 ,12,8 ,img,width);
			inter_idct_luma(LumTmp+32,pre+4*width,8 ,12,img,width);
			inter_idct_luma(LumTmp+48,pre+4*width+4,12,12,img,width);
		}
		
		
		cr_cbp=intra_dct_chroma(0,cr_cbp,imgUV_org[0]+img->pix_c_y*width_cr+img->pix_c_x,MbCb,img);
		cr_cbp=intra_dct_chroma(1,cr_cbp,imgUV_org[1]+img->pix_c_y*width_cr+img->pix_c_x,MbCr,img);
		cbp += cr_cbp*16;
		img->cbp=cbp;
		
		if(cbp==0 && curr_mvx==skip_mv[0]&& curr_mvy==skip_mv[1]&&img->mb_mode==1)
		{
			img->mb_mode=COPY_MB;
		} 
    }//if(img->imod == INTRA_MB_INTER)
    else
    {
		img->mb_mode=img->imod+8*img->type; 
		for(i=0;i<4;i++)
		{
			tmp_mv[pic_block_y][pic_block_x+4+i][0]=0;
			tmp_mv[pic_block_y][pic_block_x+4+i][1]=0;
			tmp_mv[pic_block_y+1][pic_block_x+4+i][0]=0;
			tmp_mv[pic_block_y+1][pic_block_x+4+i][1]=0;
			tmp_mv[pic_block_y+2][pic_block_x+4+i][0]=0;
			tmp_mv[pic_block_y+2][pic_block_x+4+i][1]=0;
			tmp_mv[pic_block_y+3][pic_block_x+4+i][0]=0;
			tmp_mv[pic_block_y+3][pic_block_x+4+i][1]=0;
			intra_mb_pos[pic_block_y][pic_block_x+4+i] = 1;
			intra_mb_pos[pic_block_y+1][pic_block_x+4+i] = 1;
			intra_mb_pos[pic_block_y+2][pic_block_x+4+i] = 1;
			intra_mb_pos[pic_block_y+3][pic_block_x+4+i] = 1;
		}
		for(i=0;i<4;i++)
		{
			intra_mb_pos1[pic_block_y][pic_block_x+4+i] = 1;
			intra_mb_pos1[pic_block_y+1][pic_block_x+4+i] = 1;
			intra_mb_pos1[pic_block_y+2][pic_block_x+4+i] = 1;
			intra_mb_pos1[pic_block_y+3][pic_block_x+4+i] = 1;
		}
		Copy_tmpmv(img);
    	IntraMb_Chroma(img);
		/*yummy*/
		img->i16offset = (img->mb_mode == I16MB)? ((img->cbp&15?13:1) + img->i16offset + ((img->cbp&0x30)>>2)) :0;
    }
}
